/**************************************************************************
 *
 *  Cross-functions in time domain
 *  Copyright (c) 2005 Angelo Farina.  All Rights Reserved.
 * 
 **************************************************************************/

#include <windows.h>
#include <math.h>        
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdio.h>
#include "resource.h"
#include "xfunc.h" 
#include "xfmsdll.c" 

long longfromstring(char **cursor)
{   long l=0;
	while ((**cursor!=',') && (**cursor!=0x00))
	{	l=l*10+(long)(**cursor-'0');
		(*cursor)++;	
	}          
	if (**cursor!=0x00)  // skip over comma
		(*cursor)++;
 	
 	return l;
}

BOOL WINAPI DllMain (HANDLE hModule, DWORD fdwReason, LPVOID lpReserved)
{
   switch (fdwReason)
   {
      case DLL_PROCESS_ATTACH:
         break;
 
      case DLL_THREAD_ATTACH:
         
         break;
 
      case DLL_THREAD_DETACH:
         
         break;
 
      case DLL_PROCESS_DETACH:
         
         break;
   }
 
   return TRUE;   
}


// Fill XFMQUERY structure with information regarding this file filter

__declspec(dllexport) short FAR PASCAL QueryXfm(XFMQUERY far * cq)
{   
	lstrcpy(cq->szName,TRANSFORMNAME);         
	lstrcpy(cq->szCopyright,"Copyright (c) 2004 A.Farina"); 

	cq->wSupports=XFM_STEREO16|XFM_STEREO32; // va solo con segnale in input stereo
	cq->dwFlags=XF_TRANSFORM|XF_USESPRESETSAPI|XF_MUSTHIGHLIGHT|XF_USESGRAPHAPI|XF_USES32BITAPI|XF_SPECTRALEDITOK;
	cq->dwUserDataLength = sizeof(MLS);
	lstrcpy(cq->szStructDef,STRUCTDEFINITION);
	lstrcpy(cq->szPresetDef,PRESETDEFINITION);
	lstrcpy(cq->szToolHelp,"Cross Functions");
	return XFM_VALIDLIBRARY;
} 

__declspec(dllexport) BOOL FAR PASCAL XfmInit(COOLINFO far *ci)
{	MLS FAR * lpAmp;
	HANDLE hTones;
	hTones=ci->hUserData;         
	lpAmp=(MLS FAR *)GlobalLock(hTones);
	if (!lpAmp)
		return FALSE;
		
	lpAmp->FFTsize=6; // 16384 points
	lpAmp->Xtype=0;  // Cross spectrum
	lpAmp->Wtype=1;  // Hanning
	lpAmp->RemoveDC=FALSE;
	lpAmp->OctBand=0.33f;
	lpAmp->FollFlag=0; // False
	lpAmp->CohFlag=0;  // False
	lpAmp->hWnd=NULL;
	lpAmp->hInst=NULL;
	lpAmp->Trig=50; // 50% del FS
	lpAmp->c=343; // m/s
	lpAmp->d=40;  // mm
	lpAmp->fmax=1900; // Hz
	lpAmp->Shift=1;
	lpAmp->RemoveDC=1;
	// ricerca del file AuroKey.txt
{
	char name[256];
	char regkey[256];
	char LF=10;
	long stop;
	HANDLE nFile;
	DWORD i,Pointer;
	
	char pathbuffer[_MAX_PATH];   
	char searchfile[] = "AuroKey.txt";
	char envvar[] = "PATH";   /* Search for file in PATH environment variable: */
	_searchenv( searchfile, envvar, pathbuffer );   
	if ( *pathbuffer == '\0' )
	// Non trovato, cerco quello specifico (convolv.txt)
	{
		char searchfile2[] = "CrosFunc.txt";
		char envvar2[] = "PATH";
		_searchenv( searchfile2, envvar2, pathbuffer );   
	}
	if( *pathbuffer != '\0' )
	{
        nFile=CreateFile(pathbuffer, 
		GENERIC_READ, 0,
		NULL,	// pointer to security descriptor 
		OPEN_EXISTING ,	// how to create 
		FILE_ATTRIBUTE_NORMAL,	// file attributes 
		0 	// handle to file with attributes to copy  
		);
		// Lettura Name
		i=0;
		stop=0;
		while (!stop)
		{
			ReadFile(nFile,	// handle of file to read 
			&name[i],	// address of buffer that receives data  
			(1L),	// number of bytes to read 
			&Pointer,	// address of number of bytes read 
			NULL);	// address of structure for data 
			if (name[i]==LF) stop=-1;
			i=i+1;
		}
		name[i-1]=0;
		name[i-2]=0;
		strcpy(lpAmp->username,name);

		// Lettura regkey
		i=0;
		stop=0;
		while (!stop)
		{
			ReadFile(nFile,	// handle of file to read 
			&regkey[i],	// address of buffer that receives data  
			(1L),	// number of bytes to read 
			&Pointer,	// address of number of bytes read 
			NULL);	// address of structure for data 
			if (regkey[i]==LF) stop=-1;
			i=i+1;
		}
		regkey[i-1]=0;
		regkey[i-2]=0;
		strcpy(lpAmp->regkey,regkey);
	CloseHandle(nFile);
	}
}
// fine lettura da file


	GlobalUnlock(hTones);
	return TRUE;
}

__declspec(dllexport) BOOL FAR PASCAL XfmDestroy(COOLINFO far *ci)
{   MLS FAR * lpAmp;
	HANDLE hTones;
	hTones=ci->hUserData;         
	lpAmp=(MLS FAR *)GlobalLock(hTones);
	if (!lpAmp)
		return FALSE;                       
		
 	// Do your de-initialization here
 	                
 	GlobalUnlock(hTones);
	return TRUE;
}

__declspec(dllexport) BOOL FAR PASCAL XfmSetup(HWND hWnd, HINSTANCE hInst, COOLINFO far *ci)
{	
	char ok=TRUE; 
	char goout=0;
	char booltoreturn=TRUE;
	char ClipFlag=TRUE;
	long ClipSamples=0;

// Chiamo la finestra di inizializzazione
	{
	    MLS FAR * lpAmp;
		HANDLE hCotype;  
		short nRc;
		FARPROC lpfnDIALOGMsgProc; 
		hCotype=ci->hUserData;         
		lpAmp=(MLS FAR *)GlobalLock(hCotype);
		if (!lpAmp) nRc=FALSE;
	    else             
		{
			lpfnDIALOGMsgProc = GetProcAddress(hInst,(LPCSTR)MAKELONG(100,0));
			nRc = DialogBoxParam((HINSTANCE)hInst,(LPCSTR)MAKEINTRESOURCE(IDD_TRANSFORM), (HWND)hWnd, (DLGPROC)lpfnDIALOGMsgProc,(DWORD)ci);
			switch (nRc)
			{
				case 0:
					booltoreturn=FALSE;
					break;
				case 1:
    			{   
					// se devo proseguire inizializzo i campi hWnd e hInst di ci->hUserData
					// per la procedura XfmDo
					lpAmp->hWnd=hWnd;
					lpAmp->hInst=hInst;                                            
					// MessageBox(hWnd,"Processing data...","Control Message 1",MB_ICONSTOP|MB_OK);
				} // case 1
				break;
				case 2:
				{   
					// se la zona evidenziata  troppo piccola
					MessageBox(hWnd,"Highlighted area is too short to perform\nthe processing with this FFT size","Cross Functions 2",MB_ICONSTOP|MB_OK);
					booltoreturn=FALSE;
				}
				break;
			}
			GlobalUnlock(hCotype);
		} // fine IF
	} // fine gestione finestra inizializzazione
	// prima unlocko i dati copiati dalla clipboard, poi se devo uscire ritorno FALSE, 
	// altrimenti ritorno TRUE
	return booltoreturn;
}


void FindXmax(float  *ToSearch,DWORD TS,float *Xmax,long *MaxPos,float *DCOffset)
{
	float XM=0.0f;
	float Xi;
	float Tot=0.0; // uso un double per maggior precisione
				    // ed immunit ad overflow
	DWORD i,MP;

	// se NON devo rimuovere il DCOffset
	if (*DCOffset==0.0f)
	{
		for(i=0;i<TS;i++)
		{
			Xi=(float)fabs(ToSearch[i]);
			if(Xi>XM) {XM=Xi; MP=i;}
		}
	}
	// se devo rimuovere il DCOffset
	else
	{
		// inizializzo la somma dei valori a zero
		Tot=0.0;
		for(i=0;i<TS;i++)	Tot+=ToSearch[i];
		// calcolo il DC offset e lo memorizzo in Tot
		Tot/=TS;      
		// ORA GLIELO VADO A TOGLIERE e intanto cerco il max
		for(i=0;i<TS;i++)
		{	
			ToSearch[i]-=Tot;
			Xi=(float)fabs(ToSearch[i]);
			if(Xi>XM) {XM=Xi; MP=i;}
		}
	}	
	// il valore di Xmax viene cambiato solo se XM ne  maggiore
	// mentre quello di MaxPos viene cambiato in ogni caso
	if (XM>*Xmax) *Xmax=XM;
	*MaxPos=MP;
}	             

short shrt(float sample)
{
	short tmp;
	if (sample>=0.0f)
	{
		tmp=(short)(sample+0.5F);
	}
	else
	{
		tmp=(short)(sample-0.5F);  
	}
	return tmp;
}

void FloatToFloatOrdered(float  *fdataL,    // buffer per i float da convertire
				float  *fdataR,
				float  *Outbuf,       // buffer di uscita
				float Xmax,           // valore massimo dei campioni
				float Ymax,           // valore massimo dei campioni
				long L,
				short TimeRev)                                         
{   
	double Xconv=32767.0/Xmax;        // valore con cui riscalare il left
	double Yconv=32767.0/Ymax;        // valore con cui riscalare il right
	long i, ii=0;
	if (TimeRev)
		for (i=(L-1);i>=0;i--) 
		{                           
			Outbuf[ii++]=(float)(fdataL[i]*Xconv);
			Outbuf[ii++]=(float)(fdataR[i]*Yconv); // il right (Coerenza)  sempre normalizzato ad 1
		}
	else
		for (i=0;i<L;i++) 
		{                           
			Outbuf[ii++]=(float)(fdataL[i]*Xconv);
			Outbuf[ii++]=(float)(fdataR[i]*Yconv); // il right (Coerenza)  sempre normalizzato ad 1
		}
}				


void fZeroPadding(float  *ToPad,long zeroes) 
// mette zeroes zeri nel vettore ToPad
{
	long i;
	
	for(i=0l;i<zeroes;i++) ToPad[i]=0.0f;
}                               

// Inizio funzioni tratte e modificate dalle numerical recipes

#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr

void four1(float  *data,unsigned long nn,short isign)
{
	unsigned long n,mmax,m,j,istep,i;
	double wtemp,wr,wpr,wpi,wi,theta;
	float tempr,tempi;

	n=nn<<1;
	j=1;
	for (i=1;i<n;i+=2) {
		if (j > i) {
			SWAP(data[j],data[i]);
			SWAP(data[j+1],data[i+1]);
		}
		m=n>>1;
		while (m >= 2 && j > m) {
			j -= m;
			m>>=1;
		}
		j += m;
	}
	mmax=2;
	while (n > mmax) {
		istep=mmax<<1;
		theta=isign*(6.28318530717959/mmax);
		wtemp=sin(0.5*theta);
		wpr = -2.0*wtemp*wtemp;
		wpi=sin(theta);
		wr=1.0;
		wi=0.0;
		for (m=1;m<mmax;m+=2) {
			for (i=m;i<=n;i+=istep) {
				j=i+mmax;
				tempr=(float)( wr*data[j]-wi*data[j+1]);
				tempi=(float) (wr*data[j+1]+wi*data[j]);
				data[j]=data[i]-tempr;
				data[j+1]=data[i+1]-tempi;
				data[i] += tempr;
				data[i+1] += tempi;
			}
			wr=(wtemp=wr)*wpr-wi*wpi+wr;
			wi=wi*wpr+wtemp*wpi+wi;
		}
		mmax=istep;
	}
}

#undef SWAP

void realft(float  *data,unsigned long n,short isign)
// n=lunghezza sequenza, non come nel manuale delle 
// numerical recipes, dove n=lunghezza sequenza/2
{
	unsigned long i,i1,i2,i3,i4,np3;
	float c1=0.5f,c2,h1r,h1i,h2r,h2i;
	double wr,wi,wpr,wpi,wtemp,theta;
	theta=3.141592653589793/(double)(n>>1);
	if (isign == 1) {
		c2 = -0.5f;
		four1(data,n>>1,1);
	} else {
		c2=0.5f;   
		theta = -theta;
	}
	wtemp=sin(0.5*theta);
	wpr = -2.0*wtemp*wtemp;
	wpi=sin(theta);
	wr=1.0+wpr;
	wi=wpi;
	np3=n+3;
	for (i=2;i<=(n>>2);i++) 
	{
		i4=1+(i3=np3-(i2=1+(i1=i+i-1)));
		h1r=c1*(data[i1]+data[i3]);
		h1i=c1*(data[i2]-data[i4]);
		h2r = -c2*(data[i2]+data[i4]);
		h2i=c2*(data[i1]-data[i3]);
		data[i1]=(float)(h1r+wr*h2r-wi*h2i);
		data[i2]=(float)(h1i+wr*h2i+wi*h2r);
		data[i3]=(float)(h1r-wr*h2r+wi*h2i);
		data[i4]=(float)(-h1i+wr*h2i+wi*h2r);
		wr=(wtemp=wr)*wpr-wi*wpi+wr;
		wi=wi*wpr+wtemp*wpi+wi;
	}
	if (isign == 1) 
	{
		data[1] = (h1r=data[1])+data[2];
		data[2] = h1r-data[2];
	} 
	else 
	{
		data[1]=c1*((h1r=data[1])+data[2]);
		data[2]=c1*(h1r-data[2]);
		four1(data,n>>1,-1);
		for (i=1;i<=n;i++) data[i]/=(n/2); //riscalatura dividendo per n/2
	}
}

// Fine funzioni tratte e modificate dalle numerical recipes 

void compmul(float  *ReOut,float  *ImOut,float  *Re1,float  *Im1,float  *Re2,float  *Im2)
{   // fa la moltiplicazione complessa dei due numeri complessi che riceve in ingresso 
	// (il primo per il  secondo) e immagazzina il risultato in uscita
	
	*ReOut=(*Re1 * *Re2 - *Im1 * *Im2);
	*ImOut=(*Im1 * *Re2 + *Re1 * *Im2);
}

void compmulc(float  *ReOut,float  *ImOut,float  *Re1,float  *Im1,float  *Re2,float  *Im2)
{   // fa la moltiplicazione complessa coniugata dei due numeri complessi che riceve in ingresso 
	// (il primo per il compl.con. del secondo) e immagazzina il risultato in uscita
	
	*ReOut=(*Re1 * *Re2 + *Im1 * *Im2);
	*ImOut=(*Im1 * *Re2 - *Re1 * *Im2);
}

void compdiv(float  *ReOut,float  *ImOut,float  *A,float  *B,float  *C,float  *D)
{   // fa la divisione complessa dei due numeri complessi individuati dai puntatori che riceve 
	// in ingresso e immagazzina il risultato nel numero complesso individuato dai puntatori Out
	float Den;
	
	Den=*C * *C + *D * *D+1.0E-12f*1.0E-12f;
	*ReOut=(*A * *C + *B * *D)/Den;
	*ImOut=(*B * *C - *A * *D)/Den;
}

void Hfilter(float *ReOut, float  *ReB,float  *ReH,long L)

// Mette in Out il rapporto complesso fra gli spettri di B ed H
{
	long i,ir,ii;
	
	ReOut[0]=ReB[0]/(ReH[0]+1.0E-12f);// DC
	ReOut[1]=ReB[1]/(ReH[1]+1.0E-12f);// Fnyq
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		compdiv(&ReOut[ir],&ReOut[ii],&ReB[ir],&ReB[ii],&ReH[ir],&ReH[ii]);
	}

}

void Dirac(float *ReOut, long L,long Fsamp,float fmax)

// Mette in Out una delta di Dirac finestrata
{
	long i,ir,ii;
	float f;
	
	ReOut[0]=1.0f;// DC
	ReOut[1]=1.0f;// Fnyq
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		f=(float)(Fsamp*i/L);
		if ((f<24.0)|(f>fmax)) 
		{
			ReOut[ir]=0.0f;
			ReOut[ii]=0.0f;
		}
		else

		{
			ReOut[ir]=1.0f;
			ReOut[ii]=0.0f;
		}
	}

}


void CalibPU(float *ReOut, float  *ReB,float  *ReH,long L,float c, float d, long Fsamp,float fmax)

// Mette in Out il rapporto complesso fra gli spettri di B ed H, e moltiplica per [0,tan(2*pi*f*d/c)]
{
	long i,ir,ii;
	float f,dd=d/1000.0f; // d in metri
	double pi=4*atan(1.0);
//	char textbuf[80];

	
	ReOut[0]=0.0f;// DC
	ReOut[1]=0.0f;// Fnyq
//	ReOut[1]=(float)(ReB[1]/(ReH[1]+1.0E-12f));// Fnyq
//	_gcvt(pi,12,textbuf);
//	MessageBox(NULL,textbuf,"pi =",MB_ICONSTOP|MB_OK);
//	_gcvt(c,12,textbuf);
//	MessageBox(NULL,textbuf,"c =",MB_ICONSTOP|MB_OK);
//	_gcvt(dd,12,textbuf);
//	MessageBox(NULL,textbuf,"dd =",MB_ICONSTOP|MB_OK);
//		_ltoa(Fsamp,textbuf,10);
//		MessageBox(NULL,textbuf,"Fsamp =",MB_ICONSTOP|MB_OK);

	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		// compdiv(&ReOut[ir],&ReOut[ii],&ReB[ir],&ReB[ii],&ReH[ir],&ReH[ii]);
		// moltiplico per [0,tan(kd)]
		// tmp=ReOut[ii];
		//ReOut[ii]=ReOut[ir];
		//ReOut[ir]=(float)(tmp*tan(2.0*pi*Fsamp*dd/c*i/L));
		f=(float)(Fsamp*i/L);
		if ((f<24.0)|(f>fmax)) 
		{
			ReOut[ir]=0.0f;
			ReOut[ii]=0.0f;
		}
		else

		{
			ReOut[ir]=(float)(ReB[ii]/(ReH[ir]+1E-12)*tan(2.0*pi*Fsamp*dd/c*i/L));
			ReOut[ii]=(float)(ReB[ir]/(ReH[ir]+1E-12)*tan(2.0*pi*Fsamp*dd/c*i/L));
		}
	}

}

void CalibPU2(float *ReOut, float  *ReB,float  *ReH,long L,float c, float d, long Fsamp,float fmax)

// Mette in Out il rapporto complesso fra gli spettri di B ed H, e divide per [1+1/jkd]
{
	long i,ir,ii;
	float f,dd=d/1000.0f; // d in metri
	double pi=4*atan(1.0);
//	char textbuf[80];

	
	ReOut[0]=0.0f;// DC
	ReOut[1]=0.0f;// Fnyq
//	ReOut[1]=(float)(ReB[1]/(ReH[1]+1.0E-12f));// Fnyq
//	_gcvt(pi,12,textbuf);
//	MessageBox(NULL,textbuf,"pi =",MB_ICONSTOP|MB_OK);
//	_gcvt(c,12,textbuf);
//	MessageBox(NULL,textbuf,"c =",MB_ICONSTOP|MB_OK);
//	_gcvt(dd,12,textbuf);
//	MessageBox(NULL,textbuf,"dd =",MB_ICONSTOP|MB_OK);
//		_ltoa(Fsamp,textbuf,10);
//		MessageBox(NULL,textbuf,"Fsamp =",MB_ICONSTOP|MB_OK);

	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		// compdiv(&ReOut[ir],&ReOut[ii],&ReB[ir],&ReB[ii],&ReH[ir],&ReH[ii]);
		// moltiplico per [0,tan(kd)]
		// tmp=ReOut[ii];
		//ReOut[ii]=ReOut[ir];
		//ReOut[ir]=(float)(tmp*tan(2.0*pi*Fsamp*dd/c*i/L));
		f=(float)(Fsamp*i/L);
		if ((f<24.0)|(f>fmax)) 
		{
			ReOut[ir]=0.0f;
			ReOut[ii]=0.0f;
		}
		else
		{
			ReOut[ir]=(float)(ReB[ir]/ReH[ir]+ReB[ii]/ReH[ir]/(2.0*pi*Fsamp*dd/c*i/L));
			ReOut[ii]=(float)(ReB[ii]/ReH[ir]-ReB[ir]/ReH[ir]/(2.0*pi*Fsamp*dd/c*i/L));
		}
	}

}

void H3filter(float *Out, float  *Gll, float *Grr, long L)

// Mette in Out la radice quadrata rapporto complesso fra gli spettri di B ed H
{
	long i,ir,ii;
	
	Out[0]=(float)sqrt(Grr[0]/(Gll[0]+1.0E-12f));
	Out[1]=(float)sqrt(Grr[1]/(Gll[1]+1.0E-12f));
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Out[ir]=(float)sqrt(Grr[ir]/(Gll[ir]+1.0E-12f));
		Out[ii]=0.0f;  // Parte immaginaria sempre nulla...
	}

}


void Cfilter(float *Out, float  *B,float  *H,long L, short block,long Lowi,long Highi)

// Calcolo Cross-Spettro
// Mette in Out il prodotto coniugato fra gli spettri di B ed H
// Normalizzato sul numero di campioni
{
	long i,ir,ii;
	float ReTmp,ImTmp;
	float block1=(float)block+1; // block parte da zero...
	if (Lowi==0)
	{
		Out[0]=(Out[0]*(float)block+B[0]*H[0])/block1;// DC
		Out[1]=(Out[1]*(float)block+B[1]*H[1])/block1;// Fnyq
	}
	for(i=1;i<(Lowi+1);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Out[ir]=(Out[ir]*(float)block)/block1;// Reale
		Out[ii]=(Out[ii]*(float)block)/block1;// Immag
	}
	for(i=(Lowi+1);i<Highi;i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		compmulc(&ReTmp,&ImTmp,&B[ir],&B[ii],&H[ir],&H[ii]);
		Out[ir]=(Out[ir]*(float)block+ReTmp)/block1;// Reale
		Out[ii]=(Out[ii]*(float)block+ImTmp)/block1;// Immag
	}
	for(i=Highi;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Out[ir]=(Out[ir]*(float)block)/block1;// Reale
		Out[ii]=(Out[ii]*(float)block)/block1;// Immag
	}
}	

void Afilter(float *Out, float  *B,long L, short block,long Lowi,long Highi)

// Calcolo Auto-Spettro
// Mette in Out il modulo di B
{
	long i,ir,ii;
	float ReTmp;
	float block1=(float)block+1.0f; // block parte da zero...

	if (Lowi==0)
	{
		Out[0]=(Out[0]*(float)block+(B[0]*B[0]))/block1;// DC
		Out[1]=(Out[1]*(float)block+(B[1]*B[1]))/block1;// Fnyq
	}
	for(i=1;i<(Lowi+1);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Out[ir]=(Out[ir]*(float)block)/block1;// Reale
		Out[ii]=0.0f;// Immag, sempre nulla nell'autospettro
	}
	for(i=(Lowi+1);i<Highi;i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		ReTmp=(B[ir]*B[ir]+B[ii]*B[ii]);
		Out[ir]=(Out[ir]*(float)block+ReTmp)/block1;// Reale
		Out[ii]=0.0f;// Immag, sempre nulla nell'autospettro
	}
	for(i=Highi;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Out[ir]=(Out[ir]*(float)block)/block1;// Reale
		Out[ii]=0.0f;// Immag, sempre nulla nell'autospettro
	}

}	

void SearchImax(float  *B,long L, long * iMax)

// Cerca il massimo di uno spettro
{
	long i,ir,ii;
	double ReTmp,Max=0.0;
	for(i=11;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		ReTmp=(B[ir]*B[ir]+B[ii]*B[ii]);
		if (ReTmp>Max)
		{
			Max=ReTmp;
			*iMax=i;
		}
	}
}	

void CohWeight(float  *ReA, float  *ReB,long L)
{
	// Pondero il primo spettro moltiplicandolo per il secondo
	long i,ir,ii;
	double Coh=0.0;
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Coh=(double)ReB[ir];
		ReA[ir]=(float)(ReA[ir]*Coh*Coh);
		ReA[ii]=(float)(ReA[ii]*Coh*Coh);
/*
		if (Coh>0.1)
		{
			ReA[ir]=(float)(ReA[ir]*Coh);
			ReA[ii]=(float)(ReA[ii]*Coh);
		}
		else
		{
			ReA[ir]=0.0f;
			ReA[ii]=0.0f;
		}
*/
    }
}	


void COHfilter(float *ReOut, float  *ReA, float  *ReB,float  *ReAB,long L)
{
	// Calcolo funzione di coerenza (normalizzata fra zero e 1)
	long i,ir,ii;
	
	ReOut[0]=(float)sqrt(ReAB[0]*ReAB[0]/(ReA[0]*ReB[0]+1.0E-12f));// DC
	ReOut[1]=(float)sqrt(ReAB[1]*ReAB[1]/(ReA[1]*ReB[1]+1.0E-12f));// Fnyq
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		ReOut[ir]=(float)sqrt((ReAB[ir]*ReAB[ir]+ReAB[ii]*ReAB[ii])/(ReA[ir]*ReB[ir]+1.0E-12f));
		ReOut[ii]=0.0f;
	}
}	

void Alpha(float *ReOut, float  *ReA, float  *ReB,float  *ReAB,long L,float c, float d, long Fsamp)
{
	// Calcolo Alpha (normalizzata fra zero e 1)
	long i,ir,ii;
	double x=d/1000.0; // d  in mm, x  in metri
	double f,k,Rr,Ri,pi,Zr,Zi;
	// float Den,A,B,C,D;
	
	pi=4.0*atan(1.0);
	ReOut[0]=0.0f;// DC
	ReOut[1]=0.0f;// Fnyq
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		f=(double)(Fsamp*i/L);
		k=2.0*pi*f/c;

		Zr=-ReAB[ir]/(ReB[ir]+1E-12);  // pv/vv = p/v
		Zi=-ReAB[ii]/(ReB[ir]+1E-12);
		
		Rr=(cos(2.0*k*x)*(Zr*Zr+Zi*Zi-1)-2.0*sin(2*k*x)*Zi)/(Zr*Zr+Zi*Zi+1+2*Zr);
		Ri=(sin(2.0*k*x)*(Zr*Zr+Zi*Zi-1)+2.0*cos(2*k*x)*Zi)/(Zr*Zr+Zi*Zi+1+2*Zr);
		ReOut[ir]=(float)((1-Rr*Rr-Ri*Ri)/(1+Rr*Rr+Ri*Ri-2*Rr));
		ReOut[ii]=(float)(2.0*Ri/(1+Rr*Rr+Ri*Ri-2*Rr));


/*
		if ((f<24.0)|(f>1800.0)) 
		{
			ReOut[ir]=0.0f;
			ReOut[ii]=0.0f;
		}
		else
		{
			ReOut[ir]=(float)(2.0*fabs(ReAB[ir])/((ReA[ir]+ReB[ir])/2.0+fabs(ReAB[ir])+1.0E-12f));
			ReOut[ii]=0.0f;
		}
*/

	}
}	


void COHfilter2(float *ReOut, float  *ReA, float  *ReB,float  *ReAB,long L)
{
	// Calcolo funzione di coerenza (normalizzata fra zero e 1)
	// il cross-spettro viene pure pesato moltiplicandolo per la coerenza (quadrata)
	long i,ir,ii;
	double Coh,Modul,Max=0.0;
	ReOut[0]=(float)sqrt(ReAB[0]*ReAB[0]/(ReA[0]*ReB[0]+1.0E-12f));// DC
	ReAB[0]=0.0f;
	ReOut[1]=(float)sqrt(ReAB[1]*ReAB[1]/(ReA[1]*ReB[1]+1.0E-12f));// Fnyq
	ReAB[1]=0.0f;
	for(i=1;i<(L/2);i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		ReOut[ir]=(float)sqrt((ReAB[ir]*ReAB[ir]+ReAB[ii]*ReAB[ii])/(ReA[ir]*ReB[ir]+1.0E-12f));
		ReOut[ii]=0.0f;
	}

	// ricerca massimo
	for(i=1;i<L/2;i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Modul=sqrt(ReAB[ir]*ReAB[ir]+ReAB[ii]*ReAB[ii]);
		if (Modul>Max) Max=Modul;
	}
	for(i=1;i<L/2;i++)
	{   
		ir=i<<1;  // indice parte reale
		ii=ir+1;  // indice parte immaginaria
		Modul=sqrt(ReAB[ir]*ReAB[ir]+ReAB[ii]*ReAB[ii]);
		Coh=ReOut[ii]*ReOut[ii];
		
		if (Modul>(0.01*Max))
		{
			ReAB[ir]=(float)(ReAB[ir]/Modul);
			ReAB[ii]=(float)(ReAB[ii]/Modul);
		}
		else
		{
			ReAB[ir]=0.0f;
			ReAB[ii]=0.0f;
		}
	}
}	

void genWINDOW(float *W, short Wtype,long L)
{
	// Generazione finestra di analisi
	long i;
	double pi=3.14159265358979;
//	char textbuf[80];
//	_ltoa(L,textbuf,10);
//	MessageBox(NULL,textbuf,"Window Size =",MB_ICONSTOP|MB_OK);
	if (Wtype==0) 
		for (i=0;i<L;i++) W[i]= (float)(1.0/32768.0);											// RECT
	else if (Wtype==1) 
		for (i=0;i<L;i++) W[i]= (float)((0.5-0.5*cos(2.0*pi*i/L))/32768.0);				        // HANN
	else if (Wtype==2) 
		for (i=0;i<L;i++) W[i]= (float)(((0.35875 -0.48829*cos(2.0*pi*i/L)
												+0.14128*cos(4.0*pi*i/L)
												-0.01168*cos(6.0*pi*i/L))/0.35875)/32768.0);	// BLACKMANN-HARRIS
	else if (Wtype==3)
	{
		for (i=0;i<(L/4);i++)       W[i]= (float)(sin(2.0*pi*i/L)/32768.0);						// FLAT-TOP
		for (i=(L/4);i<(L*3/4);i++) W[i]= (float)(1.0/32768.0);
		for (i=(L*3/4);i<L;i++)     W[i]= W[L-i-1];
	}
	else if (Wtype==4)
	{
		for (i=0;i<(L/2);i++)       W[i]= (float)(2.0*(double)i/(double)(L));					// TRIANGULAR
		for (i=(L/2);i<L;i++)       W[i]= W[L-i-1];
	}
	else if (Wtype==5)
		for (i=0;i<L;i++)		    W[i]= (float)(sin(pi*i/L)/32768.0);							// HALF-SINE
}

char ReadAndAverageData(char  *cdata,float  *ldataL, float  *ldataR,
						double *MaxMag, double *MaxPhase,long *MaxBlock,
						float *Gll, float *Grr, float *Glr, float *W,
						short Wtype, long L,short *blocks,COOLINFO *ci,
						float *RMSl,float *RMSr,float *RMSlr, short FollFlag,float OctBand,char SaveMulti)
{   // legge i dati a blocchi di L e ne fa la media spettrale

	short numblocks,block;
    float  *floatbuf=(float  *)cdata; 
    long i,iMax,Rborder;
    char ok=1;
    FILE *OUTFILE;
	long counter=0;
//	char textbuf[80];
	
	// variabili che dipendono dal numero dei canali	
	DWORD LoSample=ci->dwLoSample; // offset del primo e dell'ultimo   
	DWORD HiSample=ci->dwHiSample; // campione evidenziato (in bytes)
	long Nsamples=(long)(HiSample-LoSample+1);
	double LowFactor,HighFactor;
	long LowL,HighL;
	char Stereo=(ci->wChannels==2);
	WORD wFlags;


	wFlags=RWEX_32BIT|RWEX_STEREO;
	*RMSl=0.0f;
	*RMSr=0.0f;
	*RMSlr=0.0f;
    HighFactor=pow(2.0,(OctBand/2.0));
	LowFactor=1.0/HighFactor;

	// Apro il file se necessario
	if (SaveMulti) 
	{	
		OUTFILE  = fopen( "MultiSpectrum.txt", "wt" );
		fprintf( OUTFILE, "%s ","N ");
		// for (i=0;i<(L/2);i++) fprintf( OUTFILE, "%.3f %s ", (double)i*(double)ci->lSamprate/L,"Hz "); // Spettro Left
		// for (i=0;i<(L/2);i++) fprintf( OUTFILE, "%.1f %s ", (double)i*(double)ci->lSamprate/L,"Hz "); // Spettro Right
		for (i=0;i<(L/2);i++) fprintf( OUTFILE, "%.1f ", (double)i*(double)ci->lSamprate/L); // Spettro Right
		fprintf( OUTFILE, "\n");
		for (i=0;i<(L/2);i++) 
		{
			MaxBlock[i]=0;
			MaxMag[i]=0.0;
			MaxPhase[i]=0.0;
		}
	}

	// Calcolo la Window per fare un fade in/out corretto
	numblocks=(short)((Nsamples-L)/(L/4)+1);
	// if (numblocks==1) Wtype=0; // nessuna finestra se ho un solo block
	genWINDOW(W,Wtype,L); 

	if (numblocks<0) numblocks=0;
	// E' approssimato per difetto, potrebbe non usare l'ultimo semiblocco se incompleto
//	_ltoa(FollFlag,textbuf,10);
//	MessageBox(NULL,textbuf,"FollFlag =",MB_ICONSTOP|MB_OK);
/*
	_ltoa(L,textbuf,10);
	MessageBox(NULL,textbuf,"FFTsize =",MB_ICONSTOP|MB_OK);
	_ltoa(numblocks,textbuf,10);
	MessageBox(NULL,textbuf,"Numblocks =",MB_ICONSTOP|MB_OK);
*/	
	LowL=0;
	HighL=L/2;
	
	if (numblocks>0) for (block=0;block<numblocks;block++)
	{   
		DWORD ii=0;
		// leggo L punti dallo user's data   
/*
		_ltoa(block,textbuf,10);
		MessageBox(NULL,textbuf,"block =",MB_ICONSTOP|MB_OK);
		_ltoa(LoSample+block*L/4,textbuf,10);
		MessageBox(NULL,textbuf,"campione iniziale n. =",MB_ICONSTOP|MB_OK);
		_ltoa(LoSample+block*L/4+L,textbuf,10);
		MessageBox(NULL,textbuf,"campione finale n. =",MB_ICONSTOP|MB_OK);
*/
		ReadDataEx(ci,cdata,(LoSample+block*L/4),L,wFlags);    // va avanti di L/4 punti ogni volta
		// li estraggo in ldataL e ldataR, applicando la finestra
		for (i=0;i<L;i++) 
			{   
				ldataL[i] = floatbuf[ii++] * W[i];
				ldataR[i] = floatbuf[ii++] * W[i];
				*RMSl  += ldataL[i] * ldataL[i];
				*RMSr  += ldataR[i] * ldataR[i];
				*RMSlr += ldataL[i] * ldataR[i];
			}	
		// Ora calcolo le FFT dirette dei dati
		realft(ldataL-1,L,1);
		realft(ldataR-1,L,1);
		// Se necessario, li salvo su file
		if (SaveMulti && (counter==0))
		{
			for (i=0;i<L/2;i++) 
			{
				double magnitude= ldataR[i*2]*ldataR[i*2]+ldataR[i*2+1]*ldataR[i*2+1];
				if (magnitude > MaxMag[i]) 
				{	
					MaxMag[i]=magnitude;
					MaxPhase[i]=atan2(ldataR[i*2+1],ldataR[i*2]);
					MaxBlock[i]=block;
				}
			}
		}
		counter+=1;
		if (counter==4)	counter=0;

		// Se necessario, cerco la frequenza del picco massimo
		if (FollFlag==1) 
		{
			SearchImax(ldataL,L,&iMax);
			LowL=(long)(iMax*LowFactor);
			if (LowL<0) LowL=0;
			HighL=(long)(iMax*HighFactor);
			if (HighL>(L/2)) HighL=L/2;
		}
		if (FollFlag==2) 
		{
//			long freqMax;
			SearchImax(ldataR,L,&iMax);
//			freqMax=(long)(ci->lSamprate*iMax/L);
//			_ltoa(freqMax,textbuf,10);
//			MessageBox(NULL,textbuf,"fMax =",MB_ICONSTOP|MB_OK);
			LowL=(long)(iMax*LowFactor);
			if (LowL<0) LowL=0;
			HighL=(long)(iMax*HighFactor);
			if (HighL>(L/2)) HighL=L/2;
		}
		// Infine calcolo i valori spettrali medi
		Afilter(Gll, ldataL,L,block,LowL,HighL);
		Afilter(Grr, ldataR,L,block,LowL,HighL);
		Cfilter(Glr, ldataR,ldataL,L,block,LowL,HighL);
	    // aggiorno il progress meter
    	ProgressMeter(ci,block+1,numblocks+1);
		if (*ci->lpProgressCanceled) {ok=0; break;}
	}

	if (SaveMulti) 
	{	
		for (block=0;block<numblocks;block+=4)
		{   
			DWORD ii=0;
			ReadDataEx(ci,cdata,(LoSample+block*L/4),L,wFlags);    // va avanti di L/4 punti ogni volta
		// li estraggo in ldataR, applicando la finestra
			for (i=0;i<L;i++) 
				{   
					ldataR[i] = floatbuf[ii++] * W[i];
				}	
			// Ora calcolo le FFT dirette dei dati Right
			realft(ldataR-1,L,1);
	
			// ora salvo lo spettro del camale right, con fase riferita al punto di max magnitude
			fprintf( OUTFILE, "%i ",(block/4+1));
			for (i=0;i<L/2;i++) 
			{
				double Phase;
				double magnitude;
				double varout;
				Phase=atan2(ldataR[i*2+1],ldataR[i*2]);
				magnitude= sqrt(ldataR[i*2]*ldataR[i*2]+ldataR[i*2+1]*ldataR[i*2+1])*L/2;
				varout=magnitude*cos(Phase-MaxPhase[i]);
				fprintf( OUTFILE, "%.5f ", varout); // Spettro della risposta modale riferito al punto di max magnitude
			}
			fprintf( OUTFILE, "\n");
		}
		fclose( OUTFILE );
	}



	// ora controllo se ci sono dati residui da elaborare
	if (numblocks>0) 
		Rborder=(numblocks-1)*L/4+L;
	else
		Rborder=0;
	if (Rborder<Nsamples)
	{
		// ci sono ancora dati...
		DWORD ii=0;
		long Lres=Nsamples-numblocks*L/4;
		long Ltail=L-Lres;
/*
		_ltoa(block,textbuf,10);
		MessageBox(NULL,textbuf,"Last block =",MB_ICONSTOP|MB_OK);
		_ltoa(LoSample+block*L/4,textbuf,10);
		MessageBox(NULL,textbuf,"campione iniziale n. =",MB_ICONSTOP|MB_OK);
		_ltoa(LoSample+block*L/4+Lres,textbuf,10);
		MessageBox(NULL,textbuf,"campione finale n. =",MB_ICONSTOP|MB_OK);
*/
		ReadDataEx(ci,cdata,(LoSample+numblocks*L/4),Lres,wFlags);    
		// Ricalcolo la Window per fare un fade-out corretto
		genWINDOW(W,Wtype,Lres); 
		// li estraggo in ldataL e ldataR
		for (i=0;i<Lres;i++) 
		{   
			ldataL[i] = floatbuf[ii++] * W[i];
			ldataR[i] = floatbuf[ii++] * W[i];
			*RMSl  += ldataL[i] * ldataL[i];
			*RMSr  += ldataR[i] * ldataR[i];
			*RMSlr += ldataL[i] * ldataR[i];
		}	
		
		// Zero-paddo la coda vuota
		fZeroPadding(&ldataL[Lres],Ltail); 
		fZeroPadding(&ldataR[Lres],Ltail); 
		// Ora calcolo le FFT dirette dei dati
		realft(ldataL-1,L,1);
		realft(ldataR-1,L,1);
		// Se necessario, cerco la frequenza del picco massimo
		if (FollFlag==1) 
		{
			SearchImax(ldataL,L,&iMax);
			LowL=(long)(iMax*LowFactor);
			if (LowL<0) LowL=0;
			HighL=(long)(iMax*HighFactor);
			if (HighL>(L/2)) HighL=L/2;
		}
		if (FollFlag==2) 
		{
			SearchImax(ldataR,L,&iMax);
			LowL=(long)(iMax*LowFactor);
			if (LowL<0) LowL=0;
			HighL=(long)(iMax*HighFactor);
			if (HighL>(L/2)) HighL=L/2;
		}
		// Infine calcolo i valori spettrali medi
		Afilter(Gll, ldataL,L,block,LowL,HighL);
		Afilter(Grr, ldataR,L,block,LowL,HighL);
		Cfilter(Glr, ldataL,ldataR,L,block,LowL,HighL);
	    // aggiorno il progress meter
		numblocks+=1;
    	ProgressMeter(ci,numblocks,numblocks);
		if (*ci->lpProgressCanceled) ok=0;
	}

	*blocks=numblocks;

	
	// Calcolo i valori complessivi RMS normalizzati sulla lunghezza totale effettiva
	// e corretti per il tipo di finestra impiegata
		*RMSl  =(float)sqrt( *RMSl  / (numblocks * L));
		*RMSr  =(float)sqrt( *RMSr  / (numblocks * L));
		*RMSlr =(float)( *RMSlr / (numblocks * L));

/*
	_gcvt(*RMSl,12,textbuf);
	MessageBox(NULL,textbuf,"RMS L =",MB_ICONSTOP|MB_OK);
	_gcvt(*RMSr,12,textbuf);
	MessageBox(NULL,textbuf,"RMS R =",MB_ICONSTOP|MB_OK);
	_gcvt(*RMSlr,12,textbuf);
	MessageBox(NULL,textbuf,"RMS LR =",MB_ICONSTOP|MB_OK);
*/	
	return ok;
}						                                                            

void CircularShift(float  *H,long N2)
{
	long i;
	float tmp;
	for (i=0;i<N2;i++) 
	{
		tmp=H[i];
		H[i]=H[N2+i];
		H[N2+i]=tmp;
	}	
}        

void Hilb(float *H,long L)
{
	// Swappo parte reale ed immaginaria, e cambio segno alla prima
	float tmp;
	long i,ii;
	H[0]=0.0;  // Componente DC
	H[1]=0.0;  // Componente a fNyq
	for (i=2;i<L;i+=2) 
	{	
		ii=i+1;
		tmp= (-(H[i])); //parte reale cambiata di segno
		H[i]=H[ii];//parte immaginaria
		H[ii]=tmp;
	}
}

#pragma optimize("", off)
void RussianRoulette(void)
	{
        long i,zero,rn;
        srand( (long)(time( NULL )*1000) );
        rn=rand();
		if (rn> (3 * RAND_MAX / 4))
		{
			// Roulette russa fallita
        	MessageBox(NULL,"Hey!\n\nYour AURORA software is not properly registered!\nSorry, but now CoolEdit will crash...","Russian Roulette failed",MB_ICONSTOP|MB_OK);
			zero=0;
			i=1/zero;
		}
	}
#pragma optimize("", on)

__declspec(dllexport) BOOL FAR PASCAL XfmDo(COOLINFO far *ci)
{	
	MLS FAR * lpAmp = NULL;
	HANDLE hTones = NULL;
	DWORD losamp;
	DWORD nsamples=0L;
    // DWORD dwSamples;
	long i; //,j;
    HANDLE hdataL,hdataR,hintbuf; 
	HANDLE hGll,hGrr,hGlr,hW,hW2;
	HANDLE hMaxMag,hMaxPhase,hMaxBlock;
    char  *cdata; 
    // char far *MLSgen;
    float  *fdataL=NULL;
    float  *fdataR=NULL; 
    float *Gll,*Grr,*Glr,*W,*W2;
    short  *intbuf;
	float *Outbuf;
	double *MaxMag,*MaxPhase;
	float *Left,*Right;
	long *MaxBlock;
	WAVE_TAG far *wtp;
    long FFTorder,FFTsize;
	short Wtype,Xtype;
    long L;      
    short blocks=0;
    float Xmax=1.0f,Ymax=1.0f; 
    long MaxPosL=0,MaxPosR=0;
    float DCOffsetL=0.0f,DCOffsetR=0.0f;
    char CantAllocLevel;
    char Stereo=(ci->wChannels==2);
    char Channels=(char) ci->wChannels;
	short FollFlag,TimeRev,Hilbert;
	float OctBand;
	short Trig;
	long TrigPos;
	float TrigValue,Xi;
	HWND hWnd;
	HINSTANCE hInst;	
	char ok=1;    
	DWORD tstart,tstop;
//  Variabili per controllo registrazione
	char Username[256];
	char tmpstr[16];
    long Regkey,key,key2,seed,seed2;
	char textbuf[80];
	FILE *OUTF;

    // inizializzo le variabili usate
    hTones=ci->hUserData;         
	if (!(lpAmp=(MLS FAR *)GlobalLock(hTones))) return 1; 
	hWnd=lpAmp->hWnd;
	hInst=lpAmp->hInst;
	FFTorder=lpAmp->FFTsize+8;  //se  0, allora order=8, size=256 
	FFTsize=(long)(pow(2.0,FFTorder)+0.5);
	L=FFTsize;
	lpAmp->L=FFTsize;
	losamp=ci->dwLoSample;
	Wtype=lpAmp->Wtype;
	Xtype=lpAmp->Xtype;
	FollFlag=lpAmp->FollFlag;
	OctBand=lpAmp->OctBand;
	TimeRev=lpAmp->TimeRev;
	Hilbert=lpAmp->Hilbert;
	Trig=lpAmp->Trig;
/*
	_ltoa(FFTsize,textbuf,10);
	MessageBox(NULL,textbuf,"FFTsize =",MB_ICONSTOP|MB_OK);
	_ltoa(Wtype,textbuf,10);
	MessageBox(NULL,textbuf,"Window Type =",MB_ICONSTOP|MB_OK);
	_ltoa(Xtype,textbuf,10);
	MessageBox(NULL,textbuf,"Transform Type =",MB_ICONSTOP|MB_OK);
	_ltoa(lpAmp->RemoveDC,textbuf,10);
	MessageBox(NULL,textbuf,"Remove DC =",MB_ICONSTOP|MB_OK);
*/
//  Verifica registration Key
	seed=734+11*17; // Questo  il modulo n. 17....
	seed2=717;      // Uguale per tutti i moduli...
	strcpy(Username,lpAmp->username);
	Regkey=atol(lpAmp->regkey);
	key=0;
	for (i=0;i<(long)strlen(Username);i++)
	{
		strncpy(tmpstr,Username + i,1);
		key=key + (i+1) * (short)tmpstr[0] ;
	}
    key2=(key+1) * seed2;
	key=(key+1) * seed;
	if ((key != Regkey) && (key2!=Regkey)) RussianRoulette();
    // fine controllo registrazione

    // alloco memoria                        
	CantAllocLevel=0; // inizializzo CantAllocLevel e provo ad allocare
	// nota che, dato che gli OR vengono valutati da sin. a dx., se 
	// un handle non viene lockato, l'handle successivo non viene allocato.
	if (!(hW=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=1;	
	else if (!(W=(float  *)GlobalLock(hW)))
		CantAllocLevel=2;	
	if (!(hW2=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=3;	
	else if (!(W2=(float  *)GlobalLock(hW2)))
		CantAllocLevel=4;	
	else if (!(hintbuf=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,(L*ci->wChannels*4l)+44))) 
		// il +44  per lasciare il posto all'intestazione dei dati wave
		CantAllocLevel=5;	 
	else if (!(intbuf=(short  *)GlobalLock(hintbuf)))                          
		CantAllocLevel=6;
	else if	(!(hdataL=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l))) 
		CantAllocLevel=7;
	else if (!(fdataL=(float  *)GlobalLock(hdataL)))
		CantAllocLevel=8;
	else if (!(hdataR=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=9;	
	else if (!(fdataR=(float  *)GlobalLock(hdataR)))
		CantAllocLevel=10;
	else if (!(hGll=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=11;	
	else if (!(Gll=(float  *)GlobalLock(hGll)))
		CantAllocLevel=12;
	else if (!(hGrr=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=13;	
	else if (!(Grr=(float  *)GlobalLock(hGrr)))
		CantAllocLevel=14;	
	else if (!(hGlr=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=15;	
	else if (!(Glr=(float  *)GlobalLock(hGlr)))
		CantAllocLevel=16;	
	else if (!(hMaxMag=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=17;	
	else if (!(MaxMag=(double  *)GlobalLock(hMaxMag)))
		CantAllocLevel=18;	
	else if (!(hMaxPhase=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*4l)))
		CantAllocLevel=19;	
	else if (!(MaxPhase=(double  *)GlobalLock(hMaxPhase)))
		CantAllocLevel=20;	
	else if (!(hMaxBlock=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE|GMEM_ZEROINIT,L*2l)))
		CantAllocLevel=21;	
	else if (!(MaxBlock=(long  *)GlobalLock(hMaxBlock)))
		CantAllocLevel=22;	
	if (CantAllocLevel) // se l'allocazione non  riuscita...
	{                   // libero la parte di memoria allocata
		// ulocko gli oggetti lockati
		if (CantAllocLevel>2) GlobalUnlock(hW);
		if (CantAllocLevel>4) GlobalUnlock(hW2);
		if (CantAllocLevel>6) GlobalUnlock(hintbuf);
		if (CantAllocLevel>8) GlobalUnlock(hdataL);
		if (CantAllocLevel>10) GlobalUnlock(hdataR);
		if (CantAllocLevel>12) GlobalUnlock(hGll);
		if (CantAllocLevel>14) GlobalUnlock(hGrr);
		if (CantAllocLevel>16) GlobalUnlock(hMaxMag);
		if (CantAllocLevel>18) GlobalUnlock(hMaxPhase);
		if (CantAllocLevel>20) GlobalUnlock(hMaxBlock);
        // libero gli oggetti allocati
		if (CantAllocLevel>1) GlobalFree(hW);
		if (CantAllocLevel>3) GlobalFree(hW2);
		if (CantAllocLevel>5) GlobalFree(hintbuf);
		if (CantAllocLevel>7) GlobalFree(hdataL);
		if (CantAllocLevel>9) GlobalFree(hdataR);
		if (CantAllocLevel>11) GlobalFree(hGll);
		if (CantAllocLevel>13) GlobalFree(hGrr);
		if (CantAllocLevel>15) GlobalFree(hGlr);
		if (CantAllocLevel>16) GlobalFree(hMaxMag);
		if (CantAllocLevel>17) GlobalFree(hMaxPhase);
		if (CantAllocLevel>19) GlobalFree(hMaxBlock);
		GlobalUnlock(hTones);        
		MessageBox(hWnd,"The system cannot allocate enough memory\nto perform processing.\n\nRetry after closing some windows or\nwith a lower IRS order.","Cross Functions 2",MB_ICONSTOP|MB_OK);
		return 1;
	}	
    
    // inizializzo i puntatori ausiliari
    cdata=(char  *)intbuf; // faccio puntare temporaneamente cdata all'inizio del buffer interi
    wtp=(WAVE_TAG far *)cdata; // esso coincide con l'inizio del vettore da memorizzare nella clipboard
    intbuf=(short  *)(cdata+44); // i dati interi devono cominciare 44 bytes dopo
    Outbuf=(float  *)(cdata+44); // i dati float devono cominciare 44 bytes dopo
    cdata=(char  *)intbuf; // e cos pure quelli che leggo da Cool Edit
	Left=(float *)MaxMag;  // riutilizzo lo spazio di memoria di MaxMag per lo spettro complesso Left
	Right=(float *)MaxPhase;  // riutilizzo lo spazio di memoria di MaxPhase per lo spettro complesso Right

    // avvio il timer
    tstart=GetTickCount();
	{   // blocco di calcolo
		float RMSl=0.0f,RMSr=0.0f,RMSlr=0.0f,CC0=0.0f;
		DWORD Lp1;
        DWORD L2m1=L*2-1;
	    Lp1=L+1;

		// genero la finestra di analisi
		ProgressCreate(ci,"Averaging data...",NULL); 
		// leggo i dati da elaborare facendone la media
		// essi vengono memorizzati nei rispettivi vettori
		ok=ReadAndAverageData(cdata,fdataL,fdataR,MaxMag,MaxPhase,MaxBlock,Gll,Grr,Glr,W,Wtype,L,&blocks,ci,&RMSl,&RMSr,&RMSlr,FollFlag,OctBand,lpAmp->SaveMulti); 
		ProgressDestroy(ci);          
;

		// _ltoa(Xtype,textbuf,10);
		// MessageBox(NULL,textbuf,"Xtype =",MB_ICONSTOP|MB_OK);

		if (ok)
		{               
			// creo un nuovo progress meter
			ProgressCreate(ci,"Processing Cross Function",NULL);
			// INIZIO della elaborazione vera e propria
		    switch (Xtype)
			{
				case 0:
				{
					for (i=0;i<L;i++) fdataL[i]=Glr[i]; // Cross-correlazione
					COHfilter(fdataR, Gll, Grr, Glr, L);// Coerenza
					if (lpAmp->CohFlag) CohWeight(fdataL,fdataR,L);
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la CrossCorr in W
						Hilb(W,L);	// Faccio Hilbert della Cross-correlazione (parte immaginaria)
					}
				}         
				break;
				case 1:
				{
					Hfilter(fdataL, Glr,Gll,L);			// H1
					COHfilter(fdataR, Gll, Grr, Glr, L);// Coerenza
					if (lpAmp->CohFlag) CohWeight(fdataL,fdataR,L);
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la CrossCorr in W
						Hilb(W,L);	// Faccio Hilbert della Cross-correlazione (parte immaginaria)
					}
				}         
				break;
				case 2:
				{
					Hfilter(fdataL, Grr,Glr,L);			// H2
					COHfilter(fdataR, Gll, Grr, Glr, L);// Coerenza
					if (lpAmp->CohFlag) CohWeight(fdataL,fdataR,L);
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la CrossCorr in W
						Hilb(W,L);	// Faccio Hilbert della Cross-correlazione (parte immaginaria)
					}
				}         
				break;
				case 3:
				{
					H3filter(fdataL, Gll,Grr,L);		// H3, rapporto fra i moduli degli autospettri
					COHfilter(fdataR, Gll, Grr, Glr, L);// Coerenza
					if (lpAmp->CohFlag) CohWeight(fdataL,fdataR,L);
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la CrossCorr in W
						Hilb(W,L);	// Faccio Hilbert della Cross-correlazione (parte immaginaria)
					}
				}         
				break;
				case 4:
				{
					for (i=0;i<L;i++) fdataL[i]=Gll[i]; // Auto-spettro L
					for (i=0;i<L;i++) fdataR[i]=Grr[i]; // Auto-spettro R
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la AutoCorr L in W
						Hilb(W,L);	// Faccio Hilbert della Auto-correlazione  L (parte immaginaria)
						for (i=0;i<L;i++) W2[i]=fdataL[i];  // Ricopio la AutoCorr R in W2
						Hilb(W2,L);	// Faccio Hilbert della Auto-correlazione  R (parte immaginaria)
					}
				}         
				break;
				case 5: // Coherent cross-correlation
				{
					COHfilter2(fdataR, Gll, Grr, Glr, L);// Coerenza
					for (i=0;i<L;i++) fdataL[i]=Glr[i]; // Cross-correlazione
					if (lpAmp->CohFlag) CohWeight(fdataL,fdataR,L);
					if (Hilbert)
					{
						for (i=0;i<L;i++) W[i]=fdataL[i];   // Ricopio la CrossCorr in W
						Hilb(W,L);	// Faccio Hilbert della Cross-correlazione (parte immaginaria)
					}
				}         
				break;
				case 6: // PU Probe calibration in SW tube
				{
					lpAmp->SampleRate=ci->lSamprate; 
					Dirac(fdataL, L,(lpAmp->SampleRate),(lpAmp->fmax));					// Delta di Dirac canale Left
					CalibPU(fdataR,Glr,Grr,L,(lpAmp->c),(lpAmp->d),(lpAmp->SampleRate),(lpAmp->fmax)); // 1/H2 *tan(kd)
				}  
				break;
				case 7: // PU Alpha & Coherence
				{
					lpAmp->SampleRate=ci->lSamprate; 
					Alpha(fdataL, Gll, Grr, Glr, L,(lpAmp->c),(lpAmp->d),(lpAmp->SampleRate));    // Absorption Coefficient canale left
					COHfilter(fdataR, Gll, Grr, Glr, L);// Coerenza
				}         
				break;
				case 8: // PU Probe calibration in free field
				{
					lpAmp->SampleRate=ci->lSamprate; 
					Dirac(fdataL, L,(lpAmp->SampleRate),(lpAmp->fmax));					// Delta di Dirac canale Left
					CalibPU2(fdataR,Glr,Grr,L,(lpAmp->c),(lpAmp->d),(lpAmp->SampleRate),(lpAmp->fmax)); // 1/H2/(1+1/jkd)
				}  
				break;
			}

   			ProgressMeter(ci,1,5);
			if (*ci->lpProgressCanceled) ok=0;
			if (ok)
			{
		    	// Copio i due spettri per il grafico
				for (i=0;i<L;i++) 
				{	
					Left[i]=fdataL[i]; // Left
					Right[i]=fdataR[i]; // Right
				}
				// Memorizzo i puntatori agli spettri
				lpAmp->fXFR=(long)Left;
				lpAmp->fCOH=(long)Right;
				lpAmp->fGLL=(long)Gll;
				lpAmp->fGLR=(long)Glr;
				lpAmp->fGRR=(long)Grr;
				
				// faccio la IFFT dei dati filtrati
		    	realft(fdataL-1,L,-1); // canale sinistro
				CC0=fdataL[0]; // serve nel caso della cross-correlazione normalizzata
				_gcvt(CC0,12,textbuf);
//				MessageBox(NULL,textbuf,"CC0 =",MB_ICONSTOP|MB_OK);
				if (lpAmp->Shift) CircularShift(fdataL,L/2);
		    	ProgressMeter(ci,2,5);
				if (*ci->lpProgressCanceled) ok=0;

				realft(fdataR-1,L,-1); // canale destro
				if (lpAmp->Shift) CircularShift(fdataR,L/2);
		    	ProgressMeter(ci,3,5);

				if (Hilbert)   // Hilbert
				{
			    	realft(W-1,L,-1); // parte immaginaria di Hilbert
					if (lpAmp->Shift) CircularShift(W,L/2);
					for (i=0;i<L;i++) fdataL[i]=(float)(fdataL[i]*fdataL[i]+W[i]*W[i]); // Modulo^2
					if (Xtype==4)  // Faccio Hilbert anche del canale Right
					{
			    		realft(W2-1,L,-1); // parte immaginaria di Hilbert
						if (lpAmp->Shift) CircularShift(W2,L/2);
						for (i=0;i<L;i++) fdataR[i]=(float)(fdataR[i]*fdataR[i]+W2[i]*W2[i]); // Modulo^2
					}
				}
				if (*ci->lpProgressCanceled) ok=0;
			}	
		    // FINE della elaborazione vera e propria
			if (ok)
			{    
				// salvataggio dei risultati nella clipboard
				char clipok=1;   
				DWORD L2=L*2;
//				char textbuf[80];
				lpAmp->MaxCC=0.0f;
				lpAmp->RMSl=(float)(20.0*log(RMSl)/log(10));
				lpAmp->RMSr=(float)(20.0*log(RMSr)/log(10));
				lpAmp->RMSlr=(float)(10.0*log(fabs(RMSlr))/log(10));
				Ymax=1.0;
				// cerco il massimo di X e la sua posizione
				DCOffsetL=1.0f;
				if (Hilbert) DCOffsetL=0.0f; // Nella cross-correlazione con Hilbert non va rimossa la DC
				FindXmax(fdataL,L,&Xmax,&MaxPosL,&DCOffsetL);
				if (lpAmp->Shift) 
					lpAmp->Delay=(float)((double)(MaxPosL-L/2.0) / ci->lSamprate * 1000.0); // in ms
				else 
				{	
					if (MaxPosL<(L/2))
						lpAmp->Delay=(float)((double)(MaxPosL) / ci->lSamprate * 1000.0); // in ms
					else
						lpAmp->Delay=(float)((double)(MaxPosL-L) / ci->lSamprate * 1000.0); // in ms
				}
//				_gcvt(lpAmp->Delay,16,textbuf);
//				MessageBox(NULL,textbuf,"Delay (ms) =",MB_ICONSTOP|MB_OK);
				if (lpAmp->RemoveDC) 
				{	
					if ((Xtype==0)|(Xtype==5))
					{
						// debbo normalizzare ad 1 il solo canale left
						lpAmp->MaxCC=Xmax/CC0*RMSlr/RMSl/RMSr;
					}
					else if (Xtype==4)
					{
						// debbo normalizzare ad 1 anche il canale right
						DCOffsetR=1.0f;
						FindXmax(fdataR,L,&Ymax,&MaxPosR,&DCOffsetR);
					}
				}
				else if ((Xtype==0)|(Xtype==5))
				{
					lpAmp->MaxCC=Xmax/CC0*RMSlr/RMSl/RMSr;
					Xmax=CC0/RMSlr*RMSl*RMSr; // visualizzo il valore vero della CC normalizzata
				}
				// se il valore massimo trovato  zero allora lo pongo uguale a 1 per non avere
				// errori di divisione per zero.
				if (Xmax==0.0f) Xmax=1.0f; 
				if (Xtype==6) Xmax=1.0f;
				if (Xtype==7) Xmax=1.0f;
				if (Xtype==8) Xmax=1.0f;
				// converto i dati nel formato di uscita, riordinandoli
				FloatToFloatOrdered(fdataL,fdataR,Outbuf,Xmax,Ymax,L,TimeRev); // lo sparo fuori tutto partendo dall'inizio

				if (TimeRev) lpAmp->Delay=-lpAmp->Delay;
				
				// Ricerca del Trigger Point
				TrigValue=327.67f*(float)Trig;
//				_gcvt(TrigValue,16,textbuf);
//				MessageBox(NULL,textbuf,"TrigValue =",MB_ICONSTOP|MB_OK);
				for(i=0;i<(2*L);i+=2)
				{
					Xi=(float)fabs(Outbuf[i]);
					if(Xi>TrigValue) {TrigPos=i/2; break;}
				}
				if (lpAmp->Shift) 
					lpAmp->TrigTime=(float)((double)(TrigPos-L/2.0) / ci->lSamprate * 1000.0); // in ms
				else 
					lpAmp->TrigTime=(float)((double)(TrigPos) / ci->lSamprate * 1000.0); // in ms

				// Salvo il TrigTime ed il Delay_of_Max in coda al file OUTF
				OUTF  = fopen( "timedelay.txt", "a+t" );
				{
				    char tmpbuf[128];
					time_t ltime;
				    struct tm *today;
					time( &ltime );
					today = localtime( &ltime );
					strftime( tmpbuf, 128,"%d/%m/%Y %X", today );
					fprintf( OUTF, "%s %.3f %.3f\n", tmpbuf, lpAmp->TrigTime, lpAmp->Delay );
				}
				fclose( OUTF );

				ProgressMeter(ci,4,5);
				ProgressDestroy(ci);
				{
					FARPROC lpfnDIALOGMsgProc;
	   				// fermo il timer
	   				tstop=GetTickCount();
					// copio l'elapsed time
					lpAmp->eltime=tstop-tstart;    
					// copio il numero di blocchi su cui ho mediato
					lpAmp->numblocks=blocks; 
					// copio la freq. di campionamento
					lpAmp->SampleRate=ci->lSamprate; 
					// copio il numero di canali
					lpAmp->Channels=Channels;
					// copio l'Xmax
					lpAmp->Xmax=Xmax;
					// prima di chiamare la finestra unlocko hTones
					GlobalUnlock(hTones);
					// mando un suono di conferma
					MessageBeep(MB_OK);
					lpfnDIALOGMsgProc = GetProcAddress(hInst,(LPCSTR)MAKELONG(101,0));
					DialogBoxParam((HINSTANCE)hInst,(LPCSTR)MAKEINTRESOURCE(IDD_FINAL), (HWND)hWnd, (DLGPROC)lpfnDIALOGMsgProc,(DWORD)ci);
					// dopo la finestra lo rilocko perch poi la deinizializzazione lo unlocka
					GlobalLock(hTones);
				}

				// scrivo i dati nella clipboard
				// inizializzo l'intestazione     
				strncpy(wtp->riff,"RIFF",4);
				wtp->filelen=L*4*Channels+36l;
				strncpy(wtp->fmt,"WAVEfmt ",8);
				wtp->boh=16;
				wtp->FormatTag=1; 
				wtp->Channels=Channels;
				wtp->SamplesPerSec=ci->lSamprate;  
				wtp->AvgBytesPerSec=Channels*4*ci->lSamprate;
				wtp->BlockAlign=Channels*4;
				wtp->BitsPerSample=32;
				strncpy(wtp->datatag,"data",4);
				wtp->nbytes=L*4*Channels;
				// unlocko hintbuf	
				GlobalUnlock(hintbuf);
				// apro la clipboard e trasferisco i dati
				if (OpenClipboard(hWnd))
				{
    				clipok=EmptyClipboard(); 
    				if (clipok) SetClipboardData(CF_WAVE,hintbuf);
					if (!(CloseClipboard())) clipok=0;
				}    
				else // altrimenti messaggio e libero memoria
				{   
	   				// mando un suono di stop
	   				// MessageBeep(MB_ICONHAND);
					MessageBox(hWnd,"Can not access Clipboard Data.\nAnother application or window\nhas the Clipboard opened.","Cross Functions 2",MB_ICONSTOP|MB_OK);
	   				GlobalFree(hintbuf);	
				}
			} //OK
		} //OK
	} // fine blocco di calcolo
	// deinizializzazione
	GlobalUnlock(hW);		GlobalFree(hW);
	GlobalUnlock(hdataL);	GlobalFree(hdataL);
	GlobalUnlock(hdataR);	GlobalFree(hdataR);
	GlobalUnlock(hGll);		GlobalFree(hGll);
	GlobalUnlock(hGrr);		GlobalFree(hGrr);
	GlobalUnlock(hGlr);		GlobalFree(hGlr);
	GlobalUnlock(hMaxMag);		GlobalFree(hMaxMag);
	GlobalUnlock(hMaxPhase);	GlobalFree(hMaxPhase);
	GlobalUnlock(hMaxBlock);	GlobalFree(hMaxBlock);
	if (!(ok)) //  da fare solo se non ho scritto nella clipboard
	{
		GlobalUnlock(hintbuf);
		GlobalFree(hintbuf);
	}	
	GlobalUnlock(hTones);

	return (!(ok));
}
		
void DialogToStruct(COOLINFO *ci, HWND hWndDlg, MLS * lpAmp)
{	
	char textbuf[40];
	lpAmp->FFTsize=(long) SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_GETCURSEL,0,0L);
	lpAmp->Wtype=(short) SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_GETCURSEL,0,0L);
    lpAmp->RemoveDC=IsDlgButtonChecked(hWndDlg,IDC_REMOVEDC);
    lpAmp->Shift=IsDlgButtonChecked(hWndDlg,IDC_SHIFT);
    lpAmp->TimeRev= IsDlgButtonChecked(hWndDlg,IDC_TIMEREV);
    lpAmp->CohFlag= IsDlgButtonChecked(hWndDlg,IDC_COH);
    lpAmp->Hilbert= IsDlgButtonChecked(hWndDlg,IDC_HILB);
    lpAmp->SaveMulti= IsDlgButtonChecked(hWndDlg,IDC_SAVEMULTI);

    if (IsDlgButtonChecked(hWndDlg,IDC_CROS)) lpAmp->Xtype=0;
    if (IsDlgButtonChecked(hWndDlg,IDC_H1))   lpAmp->Xtype=1;
    if (IsDlgButtonChecked(hWndDlg,IDC_H2))   lpAmp->Xtype=2;
    if (IsDlgButtonChecked(hWndDlg,IDC_H3))   lpAmp->Xtype=3;
    if (IsDlgButtonChecked(hWndDlg,IDC_AUTO)) lpAmp->Xtype=4;
    if (IsDlgButtonChecked(hWndDlg,IDC_CCC))  lpAmp->Xtype=5;
    if (IsDlgButtonChecked(hWndDlg,IDC_CALIBPU))  lpAmp->Xtype=6;
    if (IsDlgButtonChecked(hWndDlg,IDC_ALPHA))    lpAmp->Xtype=7;
    if (IsDlgButtonChecked(hWndDlg,IDC_CALIBPU2))  lpAmp->Xtype=8;
    if (IsDlgButtonChecked(hWndDlg,IDC_ENFILT))
	{
	    if (IsDlgButtonChecked(hWndDlg,IDC_LEFT))
			lpAmp->FollFlag=1;
		else
			lpAmp->FollFlag=2;
	}
	else
		lpAmp->FollFlag=0;
    GetDlgItemText(hWndDlg,IDC_OCT,textbuf,10);
    lpAmp->OctBand=(float)atof(textbuf);
    GetDlgItemText(hWndDlg,IDC_C,textbuf,10);
    lpAmp->c=(float)atof(textbuf);
    GetDlgItemText(hWndDlg,IDC_D,textbuf,10);
    lpAmp->d=(float)atof(textbuf);
    GetDlgItemText(hWndDlg,IDC_FMAX,textbuf,10);
    lpAmp->fmax=(float)atof(textbuf);
    GetDlgItemText(hWndDlg,IDC_TRIG,textbuf,10);
    lpAmp->Trig=(short)atoi(textbuf);
    GetDlgItemText(hWndDlg,IDC_USERNAME,lpAmp->username,256);
    GetDlgItemText(hWndDlg,IDC_REGKEY,lpAmp->regkey,256);
}

void StructToDialog(COOLINFO *ci, MLS *lpAmp, HWND hWndDlg)
{   
	char textbuf2[40];
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"256")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"512")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"1024")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"2048")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"4096")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"8192")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"16384")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"32768")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"65536")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"131072")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"262144")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"524288")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"1048576")); 
    SendDlgItemMessage(hWndDlg,IDC_FFTSIZE,CB_SETCURSEL,lpAmp->FFTsize,0L); 
    
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"RECT")); 
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"HANNING")); 
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"BLACKMAN")); 
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"FLAT-TOP")); 
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"TRIANGULAR")); 
	SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_ADDSTRING,0,(LPARAM)((LPCSTR)"HALF-SINE")); 
    SendDlgItemMessage(hWndDlg,IDC_WINDOW,CB_SETCURSEL,lpAmp->Wtype,0L); 

	if (lpAmp->RemoveDC) CheckDlgButton(hWndDlg,IDC_REMOVEDC,1);    
	if (lpAmp->Shift)    CheckDlgButton(hWndDlg,IDC_SHIFT,1);    
	if (lpAmp->TimeRev)  CheckDlgButton(hWndDlg,IDC_TIMEREV,1);    
	if (lpAmp->CohFlag)  CheckDlgButton(hWndDlg,IDC_COH,1);    
	if (lpAmp->Hilbert)  CheckDlgButton(hWndDlg,IDC_HILB,1);    
	if (lpAmp->SaveMulti)  CheckDlgButton(hWndDlg,IDC_SAVEMULTI,1);    

	if (lpAmp->Xtype==0) CheckDlgButton(hWndDlg,IDC_CROS,1);    
	if (lpAmp->Xtype==5) CheckDlgButton(hWndDlg,IDC_CCC,1);    
	if (lpAmp->Xtype==1) CheckDlgButton(hWndDlg,IDC_H1,1);    
	if (lpAmp->Xtype==2) CheckDlgButton(hWndDlg,IDC_H2,1);    
	if (lpAmp->Xtype==3) CheckDlgButton(hWndDlg,IDC_H3,1);    
	if (lpAmp->Xtype==4) CheckDlgButton(hWndDlg,IDC_AUTO,1);    
	if (lpAmp->Xtype==6) CheckDlgButton(hWndDlg,IDC_CALIBPU,1);    
	if (lpAmp->Xtype==7) CheckDlgButton(hWndDlg,IDC_ALPHA,1);    
	if (lpAmp->Xtype==8) CheckDlgButton(hWndDlg,IDC_CALIBPU2,1);    
    if (lpAmp->FollFlag==0)
		{
			CheckDlgButton(hWndDlg,IDC_ENFILT,0);
			EnableWindow(GetDlgItem(hWndDlg,IDC_OCT),FALSE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_LEFT),FALSE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_RIGHT),FALSE);
			EnableWindow(GetDlgItem(hWndDlg,ID_BANDWIDTH),FALSE);
		}
	else if (lpAmp->FollFlag==1)
		{
			CheckDlgButton(hWndDlg,IDC_ENFILT,1);
			EnableWindow(GetDlgItem(hWndDlg,IDC_OCT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_LEFT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_RIGHT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,ID_BANDWIDTH),TRUE);
			CheckDlgButton(hWndDlg,IDC_LEFT,1);
		}
	else
		{
			CheckDlgButton(hWndDlg,IDC_ENFILT,1);
			EnableWindow(GetDlgItem(hWndDlg,IDC_OCT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_LEFT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,IDC_RIGHT),TRUE);
			EnableWindow(GetDlgItem(hWndDlg,ID_BANDWIDTH),TRUE);
			CheckDlgButton(hWndDlg,IDC_RIGHT,1);
		}

	sprintf(textbuf2,"%.2f",lpAmp->OctBand);
    SetDlgItemText(hWndDlg,IDC_OCT,textbuf2); 
	sprintf(textbuf2,"%.1f",lpAmp->c);
    SetDlgItemText(hWndDlg,IDC_C,textbuf2); 
	sprintf(textbuf2,"%.1f",lpAmp->d);
    SetDlgItemText(hWndDlg,IDC_D,textbuf2); 
	sprintf(textbuf2,"%.1f",lpAmp->fmax);
    SetDlgItemText(hWndDlg,IDC_FMAX,textbuf2); 
	sprintf(textbuf2,"%i",lpAmp->Trig);
    SetDlgItemText(hWndDlg,IDC_TRIG,textbuf2); 

	SetDlgItemText(hWndDlg,IDC_USERNAME,lpAmp->username); 
    SetDlgItemText(hWndDlg,IDC_REGKEY,lpAmp->regkey); 
}    
    
void CopyToDlgItem(HWND hWndDlg, short iControl,COOLINFO far *ci,HANDLE hAmplify,MLS FAR *lpAmp)
{   char m[80];
	wsprintf(m,"%ld,%d,%ld",lpAmp,hAmplify,ci);
	SetDlgItemText(hWndDlg,iControl,m);	
}                                      

void CopyFromDlgItem(HWND hWndDlg, short iControl,  COOLINFO far **ci, HANDLE *hAmplify,MLS FAR **lpAmp)
{	char m[80];
	char *cursor;         
	GetDlgItemText(hWndDlg,iControl,m,80);
	if (m[0]==0x00)
	{	*lpAmp=NULL;
		*hAmplify=0;
		*ci=NULL;
		return;
	}          
	cursor=m;
	*lpAmp=(MLS FAR *)longfromstring(&cursor);
	*hAmplify=(HANDLE)longfromstring(&cursor);
	*ci=(COOLINFO far *)longfromstring(&cursor);
	
}

__declspec(dllexport) BOOL FAR PASCAL DIALOGMsgProc(HWND hWndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   MLS FAR * lpAmp = NULL;
	HANDLE hTones = NULL;
	COOLINFO far *ci=NULL;
	short booltoreturn=FALSE;
	
	switch(Message)
   	{	case WM_INITDIALOG:
		{	ci=(COOLINFO far *)lParam;
			hTones=ci->hUserData;         
			lpAmp=(MLS FAR *)GlobalLock(hTones);
			
			CopyToDlgItem(hWndDlg,IDC_STORAGE,ci,hTones,lpAmp);
	        
			CenterDialog(ci,hWndDlg);
	        
			StructToDialog(ci, lpAmp, hWndDlg);
			
	 		// using scripts, auto OK it.
	 		if ((ci->iScriptFile!=-1) && (!ci->iScriptDialogStop))
		 		PostMessage(hWndDlg,WM_COMMAND,IDOK,0L);
		}    		
        break; /* End of WM_INITDIALOG                                 */

    case WM_CLOSE:
         /* Closing the Dialog behaves the same as Cancel               */
         PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0L);
         break; 
    case WM_COMMAND:
         CopyFromDlgItem(hWndDlg,IDC_STORAGE,&ci,&hTones,&lpAmp);
	     switch(LOWORD(wParam))
           { 
			case IDC_ENFILT:
				if (IsDlgButtonChecked(hWndDlg,IDC_ENFILT))
				{
				  EnableWindow(GetDlgItem(hWndDlg,IDC_OCT),TRUE);
				  EnableWindow(GetDlgItem(hWndDlg,IDC_LEFT),TRUE);
				  EnableWindow(GetDlgItem(hWndDlg,IDC_RIGHT),TRUE);
				  EnableWindow(GetDlgItem(hWndDlg,ID_BANDWIDTH),TRUE);
				  if (!(IsDlgButtonChecked(hWndDlg,IDC_RIGHT))) CheckDlgButton(hWndDlg,IDC_LEFT,1);
				}
				else
				{
				  EnableWindow(GetDlgItem(hWndDlg,IDC_OCT),FALSE);
				  EnableWindow(GetDlgItem(hWndDlg,IDC_LEFT),FALSE);
				  EnableWindow(GetDlgItem(hWndDlg,IDC_RIGHT),FALSE);
				  EnableWindow(GetDlgItem(hWndDlg,ID_BANDWIDTH),FALSE);
				}
				 break;  
			case IDC_CROS: case IDC_CCC: case IDC_H1: case IDC_H2: case IDC_H3:
				 EnableWindow(GetDlgItem(hWndDlg,IDC_COH),TRUE);
				 break;  
			case IDC_AUTO: 
				 EnableWindow(GetDlgItem(hWndDlg,IDC_COH),FALSE);
				 break;  
			case ID_HLP:
           		 WinHelp(hWndDlg,XFM_HELPFILE,HELP_KEY,(DWORD)((LPSTR)"Cross Functions"));
                 break;  
          	case IDOK:
               {                    	
              	  DialogToStruct(ci, hWndDlg,lpAmp);
    			  booltoreturn=1;  
				  GlobalUnlock(hTones); 
             	  hTones=NULL;
                  EndDialog(hWndDlg,booltoreturn);	
               }
               break;                                                    
            case IDCANCEL:
                 /* Ignore data values entered into the controls        */
                 /* and dismiss the dialog window returning FALSE       */
                 GlobalUnlock(hTones);
                 hTones=NULL;
                 EndDialog(hWndDlg, FALSE);
                 break;
           }
         break;    /* End of WM_COMMAND                                 */

    default:
		return FALSE;
   }
 	return TRUE;
}   

__declspec(dllexport) DWORD FAR PASCAL DisplayCallback(double fXpos, MLS *lpAmp, WORD wChartNumber, double * pfYpos)

{
	float *fXFR;
	float *fCOH;
	float *fGLL;
	float *fGLR;
	float *fGRR;
	double fact=10.0;
	long i;
	double Y;
	DWORD RetVal=FALSE;
	long L=lpAmp->L;

	fXFR=(float *)lpAmp->fXFR;
	fCOH=(float *)lpAmp->fCOH;
	fGLL=(float *)lpAmp->fGLL;
	fGRR=(float *)lpAmp->fGRR;
	fGLR=(float *)lpAmp->fGLR;
   		
	i=(long)(fXpos/lpAmp->SampleRate*L);
	if (i<1) i=1;
	if (i>(L/2-2)) i=L/2-2;
	if ((lpAmp->Xtype==0)|(lpAmp->Xtype==5)) fact=5.0; // Cross-Corr, valori gi al quadrato

	// calcolo il valore di ciascun pixel
	if (wChartNumber==1) 
		switch (lpAmp->lsel)
		{
			case 0: // niente
				Y=-100.0;
				break;
			case 1: // Autospectrum L
				Y=(double)(10.0*log10(fGLL[2*i]));
				break;
			case 2: // Magnitude
				Y=(double)(fact*log10(fXFR[2*i]*fXFR[2*i]+fXFR[2*i+1]*fXFR[2*i+1]));
				break;
			case 3: // Real
				Y=(double)(fact*log10(fXFR[2*i]*fXFR[2*i]));
				break;
			case 4: // Alpha
				Y=(double)(2.0*fabs(fGLR[2*i])/((fGLL[2*i]+fGRR[2*i])/2.0+fabs(fGLR[2*i])));
				break;
		}
	if (wChartNumber==2) 
		switch (lpAmp->rsel)
		{
			case 0: // niente
				Y=-100.0;
				break;
			case 1: // Autospectrum R
				Y=(double)(10.0*log10(fGRR[2*i]));
				break;
			case 2: // Phase
				Y=(double)(-atan2(fXFR[2*i+1],fXFR[2*i])/3.1415926535897932384626433832795*80.0);
				break;
			case 3: // Imag
				Y=(double)(fact*log10(fXFR[2*i+1]*fXFR[2*i+1]));
				break;
			case 4: // Coherence
				Y=(double)(fCOH[2*i]);
				break;
		}
	*pfYpos=Y;
		
	RetVal=TRUE;

	return RetVal;
}


//-----------------------------------------------------------------------------------
// Invia un messaggio WM_PAINT alla finestra che gestisce il display
//-----------------------------------------------------------------------------------
void UpdateDisplay(HWND hDisplayWnd)
{
	InvalidateRect(hDisplayWnd, NULL, TRUE);
	UpdateWindow(hDisplayWnd);
}


void CreateDisplay(HWND hWndDlg,COOLINFO *ci, MLS *lpAmp,DWORD LinLog)
{
		// inizializzo e creo la finestra DISPLAY
		lpAmp->hDisplayWnd = DisplayInit(ci,hWndDlg,IDC_RECT,0,DisplayCallback,lpAmp);
	
		// Ora lo imposto per le due serie di dati
		{
			double fLeft=0.0;
			double fRight=(double)(lpAmp->SampleRate/2.0); // Frequenza di Nyquist.
			double fTop;
			double fBottom;
			double fSR=(double)lpAmp->SampleRate;
			fTop=80.0;
			fBottom=-80.0;
			if (LinLog==DISPLAY_MODE_LOG) 
			{				
				fLeft=20.0;
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_XLABEL),(DWORD)(LPCSTR)"f[Hz]");
			}
			// SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_YLABEL),(DWORD)(LPCSTR)"dB");
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_GRIDCOLOR),(DWORD)RGB(64,64,64));
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_BAKCOLOR),(DWORD)RGB(0,0,0));
			// SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_TEXTCONTROL),(DWORD)IDC_TEXT);
			//serie 1, Left, Cyan
			

			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_ADDCHART),LinLog);
			if (IsDlgButtonChecked(hWndDlg,IDC_LEF))
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(0,255,0));
			if (IsDlgButtonChecked(hWndDlg,IDC_MAGN))
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(0,255,255));
			if (IsDlgButtonChecked(hWndDlg,IDC_REAL))
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(255,255,255));
			if (IsDlgButtonChecked(hWndDlg,IDC_ALF))
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(255,0,255));
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_TOPVALUE),(DWORD)&fTop);
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LEFTVALUE),(DWORD)&fLeft);
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
			SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_SAMPLERATE),(DWORD)&fSR);
				// serie 2, Right, Violet
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_ADDCHART),LinLog);
				if (IsDlgButtonChecked(hWndDlg,IDC_RIG))
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(255,0,0));
				if (IsDlgButtonChecked(hWndDlg,IDC_PHASE))
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(128,0,128));
				if (IsDlgButtonChecked(hWndDlg,IDC_IMAG))
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(128,128,128));
				if (IsDlgButtonChecked(hWndDlg,IDC_COH))
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(255,255,0));
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_TOPVALUE),(DWORD)&fTop);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LEFTVALUE),(DWORD)&fLeft);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_SAMPLERATE),(DWORD)&fSR);
			EnableWindow(lpAmp->hDisplayWnd,TRUE);
		}
}

void AcousticsToClipboard(char LowR, char *Clipdata,MLS *lpAmp, COOLINFO *ci)
{                                                                                 
	CRLFDEF;
	VTABDEF; 
	char ftext[20];
	float *fXFR;
	float *fCOH;
	float *fGLL;
	float *fGLR;
	float *fGRR;
	long i,iLimit;
	long L=lpAmp->L,L2=lpAmp->L/2;
	double Y,f;

	fXFR=(float *)lpAmp->fXFR;
	fCOH=(float *)lpAmp->fCOH;
	fGLL=(float *)lpAmp->fGLL;
	fGRR=(float *)lpAmp->fGRR;
	fGLR=(float *)lpAmp->fGLR;
   
	// Titolo
	strcpy(Clipdata,"Aurora - Cross Functions 4.1 - Spectral Values");

	switch (lpAmp->Xtype)
		{
			case 0:
			{
				// Cross-correlazione
				VTAB;strcat(Clipdata,"Transform type: Cross-Correlation");
			}         
			break;
			case 1:
			{
				// H1
				VTAB;strcat(Clipdata,"Transform type: Transfer Function H1");
			}         
			break;
			case 2:
			{
				// H2
				VTAB;strcat(Clipdata,"Transform type: Transfer Function H2");
			}         
			break;
			case 3:
			{
				// H3, rapporto fra i moduli degli autospettri
				VTAB;strcat(Clipdata,"Transform type: Transfer Function H3");
			}         
			break;
			case 4:
			{
				// Auto-spettro
				VTAB;strcat(Clipdata,"Transform type: Auto Spectra");
			}
			break;
			case 5: 
			{
				// Coherent cross-correlation
				VTAB;strcat(Clipdata,"Transform type: White Cross-Correlation");
			}
			case 6: 
			{
				// Calibration PU SW tube
				VTAB;strcat(Clipdata,"Transform type: PU probe calibration in a SW tube");
			}
			break;
			case 7: 
			{
				// Alpha
				VTAB;strcat(Clipdata,"Transform type: PU probe Absorption Coefficient / Impedance");
			}
			break;
			case 8: 
			{
				// Calibration PU free field
				VTAB;strcat(Clipdata,"Transform type: PU probe calibration in free field");
			}
			break;
		}

    CRLF;
    
    // copio i valori spettrali selezionati nella Clipboard
	strcat(Clipdata,"Freq.[Hz]");

	switch (lpAmp->lsel)
		{
			case 0: // niente
				break;
			case 1: // Autospectrum L
				VTAB;strcat(Clipdata,"GLL");
				break;
			case 2: // Magnitude
				VTAB;strcat(Clipdata,"Mag");
				break;
			case 3: // Real
				VTAB;strcat(Clipdata,"Real");
				break;
			case 4: // Alpha
				VTAB;strcat(Clipdata,"Alpha");
				break;
		}
		switch (lpAmp->rsel)
		{
			case 0: // niente
				break;
			case 1: // Autospectrum R
				VTAB;strcat(Clipdata,"GRR");
				break;
			case 2: // Phase
				VTAB;strcat(Clipdata,"Phase");
				break;
			case 3: // Imag
				VTAB;strcat(Clipdata,"Imag");
				break;
			case 4: // Coherence
				VTAB;strcat(Clipdata,"Coherence");
				break;
		}

	// se nessun valore spettrale  selezionato, allora salvo tutti 4 i valori: GLL, GRR, GLR-Re, GLR-Im	
	if((lpAmp->lsel==0)&&(lpAmp->rsel==0))
	{
		VTAB;strcat(Clipdata,"GLL");
		VTAB;strcat(Clipdata,"GRR");
		VTAB;strcat(Clipdata,"Re[GLR]");
		VTAB;strcat(Clipdata,"Im[GLR]");
	}

	CRLF;

	// Inizio il ciclo che salver tutte le frequenze
	ProgressCreate(ci,"Exporting spectral values to clipboard...",NULL); 
	iLimit=L2;
	if (LowR) iLimit=(long)(2000.0*L/ci->lSamprate);

	for(i=0;i<=iLimit;i++)
	{   
		long ir=i*2;   // indice parte reale
		long ii=i*2+1;  // indice parte immaginaria

	    // aggiorno il progress meter
    	ProgressMeter(ci,i,iLimit);
		if (*ci->lpProgressCanceled) break;
		
		f =(double)((double)i*ci->lSamprate/L);

		_gcvt(f, 10, ftext);
	    strcat(Clipdata,ftext);

		switch (lpAmp->lsel)
		{
			case 0: // niente
				break;
			case 1: // Autospectrum L
				if (i==L2) Y=(double)fGLL[1]; else Y=(double)fGLL[ir];
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 2: // Magnitude
				if (i==L2) Y=(double)fXFR[1]; else Y=(double)fXFR[ir];
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 3: // Real
				if (i==L2) Y=(double)fXFR[1]; else Y=(double)fXFR[ir];
				Y=(double)fXFR[ir];
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 4: // Alpha
				if ((f<24.0)|(i>(L/2.56)))	Y=0.0;
				else						Y=(double)(2.0*fabs(fGLR[ir])/((fGLL[ir]+fGRR[ir])/2.0+fabs(fGLR[ir])));
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
		}

		switch (lpAmp->rsel)
		{
			case 0: // niente
				break;
			case 1: // Autospectrum R
				if (i==L2) Y=(double)fGRR[1]; else Y=(double)fGRR[ir];
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 2: // Phase
				if ((i==0)|(i==L2))	Y=0.0;
				else					Y=(double)(-atan2(fXFR[ii],fXFR[ir])/3.1415926535897932384626433832795*180.0);
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 3: // Imag
				if ((i==0)|(i==L2))	Y=0.0;
				else					Y=(double)fXFR[ii];
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
			case 4: // Coherence
				if ((i==0)|(i==L2))	Y=0.0;
				else					Y=(double)(fCOH[ir]);
				_gcvt(Y, 12, ftext);
				VTAB;strcat(Clipdata,ftext);
				break;
		}

		if((lpAmp->lsel==0)&&(lpAmp->rsel==0)) // salvo GLL, GRR, Re[GLR], Im[GLR]
		{
			if (i==L2) Y=(double)fGLL[1]; else Y=(double)fGLL[ir];
			_gcvt(Y, 12, ftext); VTAB;strcat(Clipdata,ftext);
			if (i==L2) Y=(double)fGRR[1]; else Y=(double)fGRR[ir];
			_gcvt(Y, 12, ftext); VTAB;strcat(Clipdata,ftext);
			if (i==L2) Y=(double)fGLR[1]; else Y=(double)fGLR[ir];
			_gcvt(Y, 12, ftext); VTAB;strcat(Clipdata,ftext);
			if ((i==0)|(i==L2))	Y=0.0;
			else 					Y=(double)fGLR[ii];
			_gcvt(Y, 12, ftext); VTAB;strcat(Clipdata,ftext);
		}

		CRLF;
	} // fine del ciclo su tutte le frequenze

	ProgressDestroy(ci);          
    CRLF;
    strcat(Clipdata,"\0"); //Aggiungo uno zero finale
}                       


__declspec(dllexport) BOOL FAR PASCAL DIALOGMsgProc2(HWND hWndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   
	MLS FAR * lpAmp = NULL;
	HANDLE hCotype = NULL;
	COOLINFO far *ci=NULL;   
	double fTop;
	double fBottom;

	switch(Message)
   	{	
	
	case WM_INITDIALOG:
		{	
		char freqtext[15];  
		char buf[80];
		long eltime;
/*		char *buffer;
		int  decimal, sign;
*/
		ci=(COOLINFO *)lParam;
		hCotype=ci->hUserData;       
		lpAmp=(MLS FAR *)GlobalLock(hCotype); 
		CopyToDlgItem(hWndDlg,IDC_STORAGE2,ci,hCotype,lpAmp);

		eltime=(long)(pow(2.0,(double)(lpAmp->FFTsize+8))+0.5);
		wsprintf(freqtext,"%li",eltime);
		SetDlgItemText(hWndDlg,IDC_LENGHT,freqtext);
		wsprintf(freqtext,"%i",lpAmp->Channels);
		SetDlgItemText(hWndDlg,IDC_CHANNELS,freqtext); 
		wsprintf(freqtext,"%li",lpAmp->SampleRate);
		SetDlgItemText(hWndDlg,IDC_SAMPRATE,freqtext); 
		wsprintf(freqtext,"%i",lpAmp->numblocks);
		SetDlgItemText(hWndDlg,IDC_CYCLES,freqtext); 
		strcpy(buf,"Elapsed time: ");
		eltime=((long)lpAmp->eltime); 
		wsprintf(freqtext,"%li.%.3li",(eltime/1000),(eltime%1000));
		strcat(buf,freqtext);
		strcat(buf," s");
		SetDlgItemText(hWndDlg,IDC_ELTIME,buf);

		switch (lpAmp->Xtype)
		{
			case 0:
			{
				// Cross-correlazione
				strcpy(buf,"Transform type: Cross-Correlation");
			}         
			break;
			case 1:
			{
				// H1
				strcpy(buf,"Transform type: Transfer Function H1");
			}         
			break;
			case 2:
			{
				// H2
				strcpy(buf,"Transform type: Transfer Function H2");
			}         
			break;
			case 3:
			{
				// H3, rapporto fra i moduli degli autospettri
				strcpy(buf,"Transform type: Transfer Function H3");
			}         
			break;
			case 4:
			{
				// Auto-spettro L
				strcpy(buf,"Transform type: Auto Spectra");
				EnableWindow(GetDlgItem(hWndDlg,IDC_MAGN),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_PHASE),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_REAL),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_IMAG),FALSE);
			}
			break;
			case 5: 
			{
				// Coherent cross-correlation
				strcpy(buf,"Transform type: White Cross-Correlation");
			}
			case 6: 
			{
				// Calibration PU SW tube
				strcpy(buf,"Transform type: PU probe calibration in a SW tube");
				EnableWindow(GetDlgItem(hWndDlg,IDC_MAGN),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_PHASE),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_REAL),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_IMAG),FALSE);
			}
			break;
			case 7: 
			{
				// Alpha
				strcpy(buf,"Transform type: PU probe absorption coefficient");
			}
			break;
			case 8: 
			{
				// Calibration PU free field
				strcpy(buf,"Transform type: PU probe calibration in free field");
				EnableWindow(GetDlgItem(hWndDlg,IDC_MAGN),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_PHASE),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_REAL),FALSE);
				EnableWindow(GetDlgItem(hWndDlg,IDC_IMAG),FALSE);
			}
			break;
		}
		SetDlgItemText(hWndDlg,IDC_XTYPE,buf);

		_gcvt( lpAmp->RMSl, 4, buf );
		//buffer = _fcvt( lpAmp->RMSl, 2, &decimal, &sign );
		//strcpy(buf,buffer);
		strcat(buf," dB");
		SetDlgItemText(hWndDlg,IDC_RMSL,buf);
		_gcvt( lpAmp->RMSr, 4, buf );
		//buffer = _fcvt( lpAmp->RMSr, 2, &decimal, &sign );
		//strcpy(buf,buffer);
		strcat(buf," dB");
		SetDlgItemText(hWndDlg,IDC_RMSR,buf);
		_gcvt( lpAmp->RMSlr, 4, buf );
		//buffer = _fcvt( lpAmp->RMSlr, 2, &decimal, &sign );
		//strcpy(buf,buffer);
		strcat(buf," dB");
		SetDlgItemText(hWndDlg,IDC_RMSLR,buf);
		if (!(lpAmp->MaxCC==0.0f))
		{
			strcpy(buf,"NCC Max: ");
			_gcvt( (lpAmp->MaxCC*100.0), 5, freqtext );
			strcat(buf,freqtext);
			strcat(buf,"%  at ");
			_gcvt( lpAmp->Delay, 4, freqtext );
			strcat(buf,freqtext);
			strcat(buf," ms");
			SetDlgItemText(hWndDlg,IDC_MAXCC,buf);
		// Trigger Time
			strcpy(buf,"Trigger Time: ");
			wsprintf(freqtext,"%i",lpAmp->Trig);
			strcat(buf,freqtext);
			strcat(buf,"%  at ");
			_gcvt( lpAmp->TrigTime, 4, freqtext );
			strcat(buf,freqtext);
			strcat(buf," ms");
			SetDlgItemText(hWndDlg,IDC_TRIGGER,buf);
		}
		CheckDlgButton(hWndDlg,IDC_LEF,1);
		CheckDlgButton(hWndDlg,IDC_RIG,1);
		CheckDlgButton(hWndDlg,IDC_DB,1);
		CheckDlgButton(hWndDlg,IDC_HIGHFREQ,1);
		lpAmp->lsel=1;
		lpAmp->rsel=1;

		CreateDisplay(hWndDlg, ci, lpAmp,DISPLAY_MODE_LOG);

 		// using scripts, auto OK it.
 		if ((ci->iScriptFile!=-1) && (!ci->iScriptDialogStop))
	 		PostMessage(hWndDlg,WM_COMMAND,IDOK,0L);
		}    		
    	break; /* End of WM_INITDIALOG                                 */
			
    case WM_CLOSE:
         /* Closing the Dialog behaves the same as OK               */
         PostMessage(hWndDlg, WM_COMMAND, IDOK, 0L);
         break; 

    case WM_COMMAND:
         CopyFromDlgItem(hWndDlg,IDC_STORAGE2,&ci,&hCotype,&lpAmp);
	     switch(LOWORD(wParam))
		 {	
			case IDC_LINVIEW:
				if (IsDlgButtonChecked(hWndDlg,IDC_LINVIEW))
				{
					DestroyWindow(lpAmp->hDisplayWnd);
					CreateDisplay(hWndDlg, ci, lpAmp,DISPLAY_MODE_NORMAL);
				}
				else
				{
					DestroyWindow(lpAmp->hDisplayWnd);
					CreateDisplay(hWndDlg, ci, lpAmp,DISPLAY_MODE_LOG);
				}
			// break;
			
			case IDC_DB:
				if (IsDlgButtonChecked(hWndDlg,IDC_DB))
				{
					fTop=80.0;
					fBottom=-80.0;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_TOPVALUE),(DWORD)&fTop);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_TOPVALUE),(DWORD)&fTop);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
				}
				UpdateDisplay(lpAmp->hDisplayWnd);

			// break;
			
			case IDC_LIN:
				if (IsDlgButtonChecked(hWndDlg,IDC_LIN))
				{
					fTop=1.2;
					fBottom=0.0;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_TOPVALUE),(DWORD)&fTop);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_TOPVALUE),(DWORD)&fTop);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
				}
				UpdateDisplay(lpAmp->hDisplayWnd);
			// break;
			
			case IDC_LOWFREQ:
				if (IsDlgButtonChecked(hWndDlg,IDC_LOWFREQ))
				{
					double fRight=2000.0; // Frequenza Max per Alpha
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
				}
				UpdateDisplay(lpAmp->hDisplayWnd);
			// break;

			case IDC_HIGHFREQ:
				if (IsDlgButtonChecked(hWndDlg,IDC_HIGHFREQ))
				{
					double fRight=(double)(lpAmp->SampleRate/2.0); // Frequenza di Nyquist.
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
				}
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_LEF:
				if (IsDlgButtonChecked(hWndDlg,IDC_LEF))
				{
					CheckDlgButton(hWndDlg,IDC_MAGN,0);
					CheckDlgButton(hWndDlg,IDC_REAL,0);
					CheckDlgButton(hWndDlg,IDC_ALF,0);
					lpAmp->lsel=1;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(0,255,0));
				}
				else lpAmp->lsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_RIG:
				if (IsDlgButtonChecked(hWndDlg,IDC_RIG))
				{
					CheckDlgButton(hWndDlg,IDC_PHASE,0);
					CheckDlgButton(hWndDlg,IDC_IMAG,0);
					CheckDlgButton(hWndDlg,IDC_COH,0);
					lpAmp->rsel=1;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(255,0,0));
				}
				else lpAmp->rsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_MAGN:
				if (IsDlgButtonChecked(hWndDlg,IDC_MAGN))
				{
					CheckDlgButton(hWndDlg,IDC_LEF,0);
					CheckDlgButton(hWndDlg,IDC_REAL,0);
					CheckDlgButton(hWndDlg,IDC_ALF,0);
					lpAmp->lsel=2;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(0,255,255));
				}
				else lpAmp->lsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_PHASE:
				if (IsDlgButtonChecked(hWndDlg,IDC_PHASE))
				{
					CheckDlgButton(hWndDlg,IDC_RIG,0);
					CheckDlgButton(hWndDlg,IDC_IMAG,0);
					CheckDlgButton(hWndDlg,IDC_COH,0);
					lpAmp->rsel=2;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(128,0,128));
				}
				else lpAmp->rsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_REAL:
				if (IsDlgButtonChecked(hWndDlg,IDC_REAL))
				{
					CheckDlgButton(hWndDlg,IDC_LEF,0);
					CheckDlgButton(hWndDlg,IDC_MAGN,0);
					CheckDlgButton(hWndDlg,IDC_ALF,0);
					lpAmp->lsel=3;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(255,255,255));
				}
				else lpAmp->lsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_IMAG:
				if (IsDlgButtonChecked(hWndDlg,IDC_IMAG))
				{
					CheckDlgButton(hWndDlg,IDC_RIG,0);
					CheckDlgButton(hWndDlg,IDC_PHASE,0);
					CheckDlgButton(hWndDlg,IDC_COH,0);
					lpAmp->rsel=3;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(128,128,128));
				}
				else lpAmp->rsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_COH:
				if (IsDlgButtonChecked(hWndDlg,IDC_COH))
				{
					CheckDlgButton(hWndDlg,IDC_RIG,0);
					CheckDlgButton(hWndDlg,IDC_PHASE,0);
					CheckDlgButton(hWndDlg,IDC_IMAG,0);
					lpAmp->rsel=4;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RGB(255,255,0));
				}
				else lpAmp->rsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDC_ALF:
				if (IsDlgButtonChecked(hWndDlg,IDC_ALF))
				{
					CheckDlgButton(hWndDlg,IDC_LEF,0);
					CheckDlgButton(hWndDlg,IDC_MAGN,0);
					CheckDlgButton(hWndDlg,IDC_REAL,0);
					lpAmp->lsel=4;
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)RGB(255,0,255));
				}
				else lpAmp->lsel=0;
				UpdateDisplay(lpAmp->hDisplayWnd);
			break;

			case IDOK:     // se  stato premuto OK
				 GlobalUnlock(hCotype); 
				 hCotype=NULL;  
            	 EndDialog(hWndDlg,TRUE);
            break;

			case IDOK2:     // se  stato premuto OK2, debbo salvare i dati spettrali nella clipboard
			{ // inizio del blocco di gestione della clipboard
				HANDLE hClipdata;
				char *Clipdata;
				char ok=TRUE;
				char LowR;

				LowR=IsDlgButtonChecked(hWndDlg,IDC_LOWFREQ);

				// alloco memoria
				if (hClipdata=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,120*lpAmp->L))
				{	
					if (!(Clipdata=(char *)GlobalLock(hClipdata)))
					{
						GlobalFree(hClipdata);
						ok=FALSE;
					}	                               
		        }
		        else ok=FALSE;
		    
			    // se l'allocazione  riuscita 
			    // memorizzo i parametri nella clipboard
				if (ok)
				{                          
					// copio i parametri nella Clipboard
					AcousticsToClipboard(LowR,Clipdata,lpAmp,ci);					
					
					// unlocko hClipdata	
					GlobalUnlock(hClipdata);
				    // copio nella clipboard
				    if (OpenClipboard(lpAmp->hWnd))
				    {                                               
				    	EmptyClipboard(); 
				    	SetClipboardData(CF_TEXT,hClipdata);
				        if (!(CloseClipboard())) ok=0;
				    }    
				    else ok=0;
				    // se non sono riuscito a scrivere nella clipboard 
				    // mando un messaggio e libero hClipdata
				    if (!(ok))
			    	{   
				    	// mando un suono di stop
				    	// MessageBeep(MB_ICONHAND);
						MessageBox(lpAmp->hWnd,"Can not access Clipboard Data.\nAnother application or window\nhas the Clipboard opened.","Acoustical Parameters",MB_ICONSTOP|MB_OK);
				  		GlobalFree(hClipdata);
				  	}	
					MessageBeep(MB_OK);
				}
			} // fine del blocco di gestione della Clipboard
			// GlobalUnlock(hCotype); 
			// hCotype=NULL;  
            // EndDialog(hWndDlg,TRUE);
            break;

         }
         break;    /* End of WM_COMMAND                                 */
    default:
		 return FALSE;
    }
 	return TRUE;
}  

