/************************************************/
/*                xfunc.h                       */
/************************************************/

// Use an Internal Structure for your function, and access it through a handle
#pragma pack(1)
typedef struct mls_tag
{   
	char Channels;
	long L;
	long FFTsize;
	short Wtype; // 0=RECT, 1=HANN, 2=BLACKMAN-HARRIS
	short Xtype; // 0=Xcorr,1=H1,2=H2,3=H3, 4=AutSpectra, 5=White CrossCorr, 6=CalibPU, 7=Alpha
	char RemoveDC;
	char Shift;
	char SaveMulti;
	short numblocks;
    DWORD eltime;
	DWORD SampleRate; 
	float Xmax;
	float RMSl;
	float RMSr;
	float RMSlr;
	float MaxCC;
	float Delay;
	short TimeRev;
	short Hilbert;  // flag for the Hilbert transform
	short FollFlag; // 0=no follower, 1=Left, 2=Right
	short CohFlag;  // flag for the Coherence Weighting
	float OctBand;  // follower filter bandwidth, in octaves
	short Trig;
	float TrigTime;
	HWND hWnd;
	HINSTANCE hInst;	
	HANDLE hClipData;
	HANDLE hDisplayWnd;
	long fGLL;		// puntatore al GLL
	long fGRR;		// puntatore al GRR
	long fGLR;		// puntatore al GLR
	long fXFR;		// puntatore alla funz.di trasferimento
	long fCOH;		// puntatore alla funz. di coerenza
	long fALF;		// puntatore alla funz. di Alfa
	short lsel;
	short rsel;
	float c;
	float d;
	float fmax;
	char  username[256];
    char  regkey[256];
} MLS;
#pragma pack()

typedef struct wave_tag
{
	char riff[4];  // RIFF
	long filelen;  // lunghezza dati in bytes + 36
	char fmt[8];   // formato: deve essere "WAVEfmt "
	long boh;      // boh, di solito  16
	short  FormatTag;// se  = 1 il formato : Microsoft Pulse Code Modulation (PCM) format
	short  Channels; // numero canali
	long SamplesPerSec;  // sample rate
	long AvgBytesPerSec; // = Channels x BitsPerSecond x BitsPerSample/8 (arrotondato short. sup.)
	short  BlockAlign;     // = Channels x BitsPerSample/8 (arrotondato all'intero superiore)
	short  BitsPerSample;  // bits per campione
	char datatag[4];     // parola "data"
	long nbytes;         // lunghezza dei dati in bytes
} WAVE_TAG;	                        

// Structure Definition for Preset and Script handling
// list variable types as:  c char
//							b BOOL
//							i short or WORD 
//							f float
//							l long or DWORD
//							d double
//							g GRAPH  
//
// Structure Preset Vars: 'y' to include in presets, 'n' to ignore.

#define STRUCTDEFINITION "clliicccillffffffiiiififhhhhlllllliifffss"
#define PRESETDEFINITION "yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy"

#define TRANSFORMNAME "Aurora\\Cross Functions"
#define CRLFDEF char crlf[]={0x0d,0x0a,0}
#define CRLF strcat(Clipdata,crlf)
#define VTABDEF char vtab[]={0x09,0}
#define VTAB strcat(Clipdata,vtab)
